/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include <iostream.h>
#include <string.h>

template<class T_item>
Array<T_item>::
Array(int size) throw()
  :s(size),haveToDelete(true)
{
  p=new T_item[s];
}

template<class T_item>
Array<T_item>::
Array(T_item *ref,int size) throw()
  :s(size),p(ref),haveToDelete(false)
{
}

template<class T_item>
Array<T_item>::
~Array() throw ()
{
  if(haveToDelete) delete[] p;
}

template<class T_item>
int 
Array<T_item>::
size() const throw()
{
  return s;
}

template<class T_item>
T_item&
Array<T_item>::
operator[](int k) throw()
{
  return *(p+k);
}

template<class T_item>
const T_item&
Array<T_item>::
operator[](int k) const throw()
{
  return *(p+k);
}

template<class T_item>
Array<T_item>::
Array(const Array<T_item>& a) throw()
  :s(a.size())
{
  p=new T_item[s];
  for(int k=0;k<s;k++) p[k]=a[k];
}

template<class T_item>
Array<T_item>& 
Array<T_item>::
operator=(const Array<T_item>& a) throw()
{
  if(a.size()<s)
    memmove((void*)p,(void*)a.p,a.size()*sizeof(T_item));
  else
    memmove((void*)p,(void*)a.p,s*sizeof(T_item));

  return *this;
}

template<class T_item>
Array<T_item>& 
Array<T_item>::
operator=(T_item i) throw()
{
  if(sizeof(T_item)==1)
    memset((void*)p,(char)i,size());
  else for(int k=0;k<size();k++) (*this)[k]=i;
  return *this;
}

