/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



template<class T_item>
Array2<T_item>::
Array2(int nbLine_j,int nbColumn_i) throw ()
  :p(nbLine_j)
{
  //%%  p=new Array1<T_item>*[s];
  for(int k=0;k<nbLine();k++)
    p[k]=new Array<T_item>(nbColumn_i);
}

template<class T_item>
Array2<T_item>::
~Array2() throw ()
{
  for(int k=0;k<nbLine();k++) delete p[k];
  //%%  delete[] p;
}

template<class T_item>
Array2<T_item>::
Array2(const Array2<T_item>& m) throw ()
  :p(m.nbLine())
{
  for(int k=0;k<nbLine();k++)
    p[k]=new Array<T_item>(m[k]);
}

template<class T_item>
Array2<T_item>& 
Array2<T_item>::
operator=(T_item i) throw ()
{
  for(int k=0;k<nbLine();k++) *p[k]=i;
  return *this;
}

template<class T_item>
Array2<T_item>& 
Array2<T_item>::
operator=(const Array2<T_item>& m) throw ()
{
  if(m.nbLine()<nbLine())
    for(int k=0;k<m.nbLine();k++) *p[k]=m[k];
  else for(int k=0;k<nbLine();k++) *p[k]=m[k];
  return *this;
}


template<class T_item>
Array<T_item>& 
Array2<T_item>::
operator[](int k) throw ()
{
  return *p[k];
}

template<class T_item>
const Array<T_item>& 
Array2<T_item>::
operator[](int k) const throw ()
{
  return *p[k];
}


template<class T_item>
int 
Array2<T_item>::
nbLine() const throw()
{
  return p.size();
}

template<class T_item>
int 
Array2<T_item>::
nbColumn() const throw()
{
  return p[0]->size();
}


