/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



template < class T_item > class Array2;

#ifndef __Array2_h__
#define __Array2_h__

#include "Array.h"

/**
   A dynamical array, more powerful than a simple [ ][ ].
   @author David FAUTHOUX
   @see Array
   @see Anim
   @see Sprite
 */
template < class T_item >
class Array2 {
 protected:
  ///
  Array< Array < T_item > * > p;
 public:
  ///
  Array2(int nbLine_j,int nbColumn_i) throw ();
  ///
  virtual ~Array2() throw ();
  ///Copies the array 'm'
  Array2(const Array2< T_item >& m) throw ();

  ///Fills the array with the item 'i'
  virtual Array2< T_item >& operator=(T_item i) throw ();
  ///Copies the array 'm'
  virtual Array2< T_item >& operator=(const Array2< T_item >& m) throw ();

  ///
  Array< T_item >& operator[](int k) throw ();
  ///
  const Array < T_item >& operator[](int k) const throw ();
  ///Vertical
  int nbLine() const throw();
  ///Horizontal
  int nbColumn() const throw();
};

#include "Array2.cc"

#endif
