/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



template < class T_item > class Array3;

#ifndef __Array3_h__
#define __Array3_h__

#include "Array.h"
#include "Array2.h"

/**
   A dynamical array, more powerful than a simple [ ][ ][ ].
   @author David FAUTHOUX
   @see Array
   @see Array2
   @see Anim
   @see Sprite
 */
template < class T_item >
class Array3 {
 private:
  ///
  Array< Array2 < T_item > * > tab;
 public:
  ///
  Array3(int deep_z,int nbLine_j,int nbColumn_i) throw ();
  ///
  ~Array3() throw ();
  ///
  Array3(const Array3< T_item >& m) throw ();
  ///
  Array3< T_item >& operator=(const Array3< T_item >& m) throw ();

  ///
  Array2< T_item >& operator[](int k) throw ();
  ///
  const Array2< T_item >& operator[](int k) const throw ();

  ///Vertical (y)
  int nbLine() const throw();
  ///Horizontal (x)
  int nbColumn() const throw();
  ///Deep (z)
  int deep() const throw();
};

#include "Array3.cc"

#endif

