/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "ArtificialIntelligenceContainer.h"
#include "BasicArtificialIntelligence.h"

ArtificialIntelligenceContainer::ArtificialIntelligenceContainer(Ini& ini) throw()
  :Walkable(0),active(-1)
{
  list.put(new BasicArtificialIntelligence(ini));
  //add here your AI

  list.place();
}

ArtificialIntelligenceContainer::~ArtificialIntelligenceContainer() throw()
{
  list.place();
  while(list.walk()) delete list.get();
}

void ArtificialIntelligenceContainer::init(Bonhomme20& bonhomme,Grille& grille) throw()
{
  list.place();
  while(list.walk()) 
    list.get()->init(bonhomme,grille);

  list.place();
  if(active>=0) {
    int cpt=0;
    while(list.walk() && cpt<active) cpt++;
  }
}

int ArtificialIntelligenceContainer::virtualWalk() throw()
{
  if(active>=0) return list.get()->walk();
  return 0;
}

bool ArtificialIntelligenceContainer::next() throw()
{
  if(!list.walk()) {
    active=-1;
    list.place();
    return false;
  }
  active++;
  return true;
}

const String *ArtificialIntelligenceContainer::getId() const throw()
{
  if(active>=0) return list.get()->getId();
  return 0;
}
