/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */

/*
  Code of my friend Ulrich ROISSARD - 1999
 */


class Blower;

#ifndef __Blower_h__
#define __Blower_h__

#include "Exploser.h"
#include "Point2D.h"
#include "Triangle.h"

#include "Tensionable.h"
#include "Redirector.h"
#include "Walkable.h"
#include "Ini.h"

// Cette classe sert a faire exploser l'ecran.

// Elle est egalement un modele pour tous ceux qui veulent utiliser la sortie
// ecran pour la sauvegarder (et faire un playback) par exemple...

// Pour activer un Redirector, il faut l'integrer a son GraphicMode (cf Main)

///
class Blower:public Redirector,public Tensionable {
 protected:
  ///
  Exploser exploser;
  ///
  PixelMatrix buffer;

  ///
  Vector *coefRotation;
  ///
  int *globalCoef;

  //  float coef;

  ///
  bool explode;
  ///
  bool reverse;

  ///
  int count;
  ///
  int maxCount;

  ///Pre-calculed int
  int jSizeDiv2;
  ///Pre-calculed int
  int iSizeDiv2;

  ///
  int minRotation;
  ///
  int maxRotation;
  ///Pre-calculed int
  int randRotation;

  ///
  int param1;
  ///
  int param2;

  ///
  int tension;
  ///
  int maxTension; 

  ///
  int virtualWalk() throw(); //sera appele par le PageChanger
  ///
  void calcCoefRotation() throw();
  ///
  void calcGlobalCoef() throw();
  ///
  void walkGlobalCoef() throw();

 public:
  ///
  Blower(Ini& ini,int jSize,int iSize) throw();
  ///
  virtual ~Blower() throw();

  ///
  virtual PixelMatrix *pipeIt(PixelMatrix& from) throw();
  // c'est avec cette fonction qu'on attrape la sortie
  // et qu'on commande l'affichage d'un nouveau tableau (qui peut etre le meme)

  ///
  virtual void blowUp() throw();

  ///
  virtual bool exploding() const throw() { return explode; }

  ///
  virtual void incTension(int puissance) throw();
};


#endif
