/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Boue;

#ifndef __Boue_h__
#define __Boue_h__

#include "MultiAnim.h"
#include "Bonhomme20.h"
#include "Tji.h"

// 'Boue' est gere a peu pres comme un 'Leaver'
// sauf qu'il est independant des cases et se pose en face du bonhomme

/**
   Mud !! Put on background pixel matrix.
   @author David FAUTHOUX
 */
class Boue:public MultiAnim {
 protected:
  ///
  const Bonhomme20 *const bonhommeRef;
  ///
  const int aUp;
  ///
  const int aDown;
  ///
  const int aLeft;
  ///
  const int aRight;
  ///
  bool toBePaint;
  ///
  bool finished;

  ///
  Tji pos[4];

  ///
  virtual int virtualWalk() throw();
  ///
  virtual void on(int id) throw (Exception);
 public:
  ///
  Boue(const Bonhomme20& b,
       Anim& animUp,Anim& animDown,
       Anim& animLeft,Anim& animRight) throw();
  ///
  virtual ~Boue() throw();
  ///
  virtual void set() throw();
  ///
  virtual void paint(WindowPipe& windowPipe) throw();
  ///
  virtual void reinit() throw();
};

#endif
