/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class CaseId;

#ifndef __CaseId_h__
#define __CaseId_h__

/**
   Declared all the Case, used with CaseGestion, Grille, Bonhomme20...
   @author David FAUTHOUX
   @see Case
   @see CaseGestion
   @see Grille
 */
class CaseId {
 public:
  ///
  enum Id {
    /**@name <i>Empty</i>*/
    //@{
    ///
    VIDE=-2,
    ///No wall on it
    VIDE_FORCE=-1,
    //@}

    /**@name <i>Bomb</i>*/
    //@{
    ///
    BOMBE=0,
    ///
    MINE,
    ///
    DYNAMITE,
    ///
    FIN_BOMBE,
    //@}

    /**@name <i>Wall or stair</i>*/
    //@{
    ///Stair
    ESCALIER,
    ///
    MUR_INDESTRUCTIBLE,
    ///
    MUR_DESTRUCTIBLE,
    ///
    MUR_BRISE,
    ///
    MUR_TAS,
    ///
    MUR_ENVOLE,

    ///Opening & closing wall
    MUR_REFERMABLE,
    ///
    MUR_REFERMABLE_OPENING,
    ///
    MUR_REFERMABLE_CLOSING,
    //@}

    /**@name <i>Flam</i>*/
    //@{
    ///
    FLAMME_CENTER,
    ///
    FLAMME_UP,
    ///
    FLAMME_DOWN,
    ///
    FLAMME_LEFT,
    ///
    FLAMME_RIGHT,
    ///End
    FLAMME_UP_BOUT,
    ///End
    FLAMME_DOWN_BOUT,
    ///End
    FLAMME_LEFT_BOUT,
    ///End
    FLAMME_RIGHT_BOUT,
    //@}

    /**@name <i>Special</i>*/
    //@{
    ///Smoke
    FUMEE,
    ///Star
    ETOILE,
    ///
    TELEPORT,
    //@}

    /**@name <i>Option</i>*/
    //@{
    ///Increase the amount of bombs you can put at the same time
    OPTION_BOMBE,//%%%%%%%%%%%=OPTION_BEGIN,
    ///Increase the power of your bombs
    OPTION_FLAMME,
    ///It's a long way magic power ! It burns the others
    OPTION_OUBA,
    ///...
    OPTION_ARMAGEDDON,
    ///It transform the others to chickens ! Walk on them !
    OPTION_CHICKEN,
    ///The others must NOT move when the flash
    OPTION_PHOTO,
    ///You leave something...
    OPTION_FEU_CUL,
    ///Your bombs will now not stop on a wall !
    OPTION_SUPER_BOMBE,
    ///If they walk on...
    OPTION_MINE,
    ///You blow up it when you want !
    OPTION_DYNAMITE,
    ///
    OPTION_INVINCIBLE,
    ///
    OPTION_INVISIBLE,
    ///You put walls
    OPTION_POSE_MUR,
    ///Your power is maximum !
    OPTION_SURPUISSANCE,
    ///Everybody knows that : Window$95 runs your computer faster ;-)
    OPTION_WIN95,
    ///The walls will not stop you
    OPTION_TRAVERSE_MUR,
    ///Under the love, you are protected
    OPTION_FEMME,
    ///Go where you want
    OPTION_TELEPORT,
    ///
    OPTION_RESURRECT,

    ///Very fast now !
    OPTION_SPEED,
    //@}



    /**@name <i>Option burning</i>*/
    //@{
    ///Increase the amount of bombs you can put at the same time
    OPTION_CRAME_BOMBE,//%%%%%%%%%%%=OPTION_BEGIN,
    ///Increase the power of your bombs
    OPTION_CRAME_FLAMME,
    ///It's a long way magic power ! It burns the others
    OPTION_CRAME_OUBA,
    ///...
    OPTION_CRAME_ARMAGEDDON,
    ///It transform the others to chickens ! Walk on them !
    OPTION_CRAME_CHICKEN,
    ///The others must NOT move when the flash
    OPTION_CRAME_PHOTO,
    ///You leave something...
    OPTION_CRAME_FEU_CUL,
    ///Your bombs will now not stop on a wall !
    OPTION_CRAME_SUPER_BOMBE,
    ///If they walk on...
    OPTION_CRAME_MINE,
    ///You blow up it when you want !
    OPTION_CRAME_DYNAMITE,
    ///
    OPTION_CRAME_INVINCIBLE,
    ///
    OPTION_CRAME_INVISIBLE,
    ///You put walls
    OPTION_CRAME_POSE_MUR,
    ///Your power is maximum !
    OPTION_CRAME_SURPUISSANCE,
    ///Everybody knows that : Window$95 runs your computer faster ;-)
    OPTION_CRAME_WIN95,
    ///The walls will not stop you
    OPTION_CRAME_TRAVERSE_MUR,
    ///Under the love, you are protected
    OPTION_CRAME_FEMME,
    ///Go where you want
    OPTION_CRAME_TELEPORT,
    ///
    OPTION_CRAME_RESURRECT,
    ///Very fast now !
    OPTION_CRAME_SPEED,
    //@}

    /**@name <i>Flam floor</i>*/
    //@{
    ///Do not walk on !
    SOL_FLAMME,//%%%%%%%%%%%=OPTION_END+1000,
    //@}

    /**@name <i>Mud floor</i>*/
    //@{
    ///Beurk !
    SOL_BOUE,
    //@}

    /**@name <i>Option floor and addon</i>*/
    //@{
    ///
    SOL_OPTION_BOMBE,//%%%%%%%=SOL_OPTION_BEGIN,
    ///
    SOL_OPTION_FLAMME,
    ///
    SOL_OPTION_OUBA,
    ///
    SOL_OPTION_ARMAGEDDON,
    ///
    SOL_OPTION_CHICKEN,
    ///
    SOL_OPTION_PHOTO,
    ///
    SOL_OPTION_FEU_CUL,
    ///
    SOL_OPTION_SUPER_BOMBE,
    ///
    SOL_OPTION_MINE,
    ///
    SOL_OPTION_DYNAMITE,
    ///
    SOL_OPTION_INVINCIBLE,
    ///
    SOL_OPTION_INVISIBLE,
    ///
    SOL_OPTION_POSE_MUR,
    ///
    SOL_OPTION_SURPUISSANCE,
    ///
    SOL_OPTION_WIN95,
    ///
    SOL_OPTION_TRAVERSE_MUR,
    ///
    SOL_OPTION_FEMME,
    ///
    SOL_OPTION_TELEPORT,
    ///
    SOL_OPTION_RESURRECT,

    ///
    SOL_OPTION_SPEED,



    //@}

    ///
    NB_ALL
    
  };

  ///
  CaseId() throw() {}
  ///
  ~CaseId() throw() {}
  
};

#endif
