/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CaseMurRefermable.h"


CaseMurRefermable::CaseMurRefermable(Anim *aniNormal,Anim *aniOpening,
				     Anim *aniClosing) throw()
  :aniNormalId(add(*aniNormal)),
   aniOpeningId(add(*aniOpening)),
   aniClosingId(add(*aniClosing)),
   step(0)
{}

bool CaseMurRefermable::traversable(bool force) throw()
{
  if(step==0) 
    if(force) {
      on(aniOpeningId);
      activateUnder=true;
      step=1;
      return true;
    }
    else return false;
  else return true;
}

int CaseMurRefermable::virtualWalk() throw()
{
  if(!MultiAnim::virtualWalk()) {
    switch(step) {
    case 1:
      on(aniClosingId);
      step=2;
      break;
    case 2:
      on(aniNormalId);
      //      unactivateUnder=true;
      step=0;
      break;
    }
  }
  return 1;
}

bool CaseMurRefermable::blowable() throw()
{
  if(step==0) {
    on(aniOpeningId);
    activateUnder=true;
    step=1;
    return true;
  }
  else return false;
}

void CaseMurRefermable::action(Bonhomme20& bonhomme) throw()
{
  if(step==0) bonhomme.setUpNiv();
}

bool CaseMurRefermable::stackable() const throw()
{
  return false; 
}
bool CaseMurRefermable::high() const throw()
{
  if(step==0) return true;
  return false;
}



