/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CaseOptionArmageddon.h"


CaseOptionArmageddon::CaseOptionArmageddon(Anim *aniNormal,Anim *aniCrame,
					   Grille& g,
					   Sounder& sounder,
					   int soundId,int soundBlowUpId) throw()
  :CaseOptionCounter(aniNormal,aniCrame,sounder,soundId,soundBlowUpId),
   grille(&g)
{}
void CaseOptionArmageddon::derivedEnd(Bonhomme20& b) throw()
{
  grille->armageddon();
}
bool CaseOptionArmageddon::blowable() throw()
{
  if(!blowed && step==0 && !sol && !got) {
    blowed=true;
    if(soundEndIdRef>=0) sounderRef->play(soundEndIdRef);
    grille->armageddon();
  }
  return CaseOptionCounter::blowable();
}
void CaseOptionArmageddon::derivedAction(Bonhomme20& b) throw()
{
  CaseOptionCounter::derivedAction(b);
  if(!sol) b.printStrip(PreStrip::CASE_OPTION_ARMAGEDDON);
}



