/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CharacterMot.h"
#include "ShakeAnim.h"

#define DEFAULT_SLOW_NORMAL 0
#define DEFAULT_SLOW_BLOWUP 0
#define DEFAULT_SHAKE_J 3
#define DEFAULT_SHAKE_I 3

CharacterMot::CharacterMot(Ini& ini,char c,Pixel col) throw (Exception)
  :blowedUp(false)
{
  setTo();

  setColor(col);

  char aux[2]={c,0};

  add(*new ShakeAnim(*ini.get("[Character]",0,aux,0),
		     ini.getWithDefault("[Slow]",0,
					"Character normal",0,
					DEFAULT_SLOW_NORMAL),
		     ini.getListSeparator(),
		     ini.getWithDefault("[Character]",0,
					"shake j",0,
					DEFAULT_SHAKE_J),
		     ini.getWithDefault("[Character]",0,
					"shake i",0,
					DEFAULT_SHAKE_I)));
  add(*new Anim(*ini.get("[Character]",0,aux,1),
		ini.getWithDefault("[Slow]",0,
				   "Character blow up",0,
				   DEFAULT_SLOW_BLOWUP),
		ini.getListSeparator()));
}

CharacterMot::~CharacterMot() throw ()
{}

void CharacterMot::blowUp() throw ()
{
  if(!blowedUp) on(1);
  blowedUp=true;
}

void CharacterMot::reinit() throw()
{
  blowedUp=false;
  MultiAnim::reinit();
}



