/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Coeur;

#ifndef __Coeur_h__
#define __Coeur_h__

#include "MultiAnim.h"
#include "Bonhomme20.h"
#include "Ini.h"
#include "CounterContainer.h"
#include "Tji.h"

// le 'Coeur' est unique dans le jeu, donc il est gere par la 'Grille'
// lorsque l'option 'femme' est prise,
// le coeur se dirige vers le preneur(bonhommeRef).
// s'il n'est pas encore existant, il est cree.

/**
   The hart is unique in the game, so when the optionFemme is taken, the hart goes to the taker. The woman loves one man at a time !
   @author David FAUTHOUX
 */
class Coeur:public MultiAnim,public CounterContainer {
 protected:
  ///
  const Bonhomme20 *bonhommeRef;
  ///
  bool haveToBeMoved;
  ///
  Tji initPos;
  ///
  const int animBegin;
  ///
  const int animEnd;

  ///
  virtual int virtualWalk() throw();
  ///
  virtual void endOfCount(int value) throw();
 public:
  ///
  Coeur(Ini& ini) throw(Exception);
  ///
  virtual ~Coeur() throw() {}
  ///
  virtual void setBonhomme(const Bonhomme20 *b) throw(); //0=> desactivation
  ///
  virtual bool isOn(const Bonhomme20& b) const throw();
  ///
  void paint(WindowPipe& windowPipe) throw();
};

#endif
