/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Counter;

#ifndef __Counter_h__
#define __Counter_h__

#include <time.h>
#include "Countable.h"
#include "Walkable.h"

#define CLOCKS_PER_MILLISEC CLOCKS_PER_SEC/1000

// 'Counter' appelle 'endOfCount' de sa reference (countableRef)
// (dans 'walk') lorsque 't' a ete depasse (compte les clocks du cpu)

/**
   Can manage delayed action on Countable objects, very interesting ! (it uses clock() C-system-function). When the time finished, Counter calls endOfCount() of the Countable.
   @see Countable
   @author David FAUTHOUX
 */
class Counter:public Walkable {
 protected:
  ///
  int cpt;
  ///
  const int value;
  ///
  Countable *const countableRef;

  ///
  virtual int virtualWalk() throw();
 public:
  ///
  Counter(int t,int v,Countable& ref) throw();
  ///
  virtual ~Counter() throw();
  ///return value
  int getValue() const throw();
};

#endif
