/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



/*
  Code of my friend Ulrich ROISSARD - 1999
 */

class Exploser;

#ifndef __Exploser_h__
#define __Exploser_h__

#include "Vector.h"
#include "Triangle3D.h"

///
class Exploser {
 protected:
  ///
  int nbTriangles;

  ///
  Vector *translationOrig;
  ///
  Vector *translation;
  ///
  Vector *rotation;
  ///
  Triangle3D *triangle;

public:
  ///
  Exploser(int width,int height,int deltaX,int deltaY) throw();

  ///
  virtual ~Exploser() throw() {}

  ///
  int getNbTriangles() const throw();

  ///
  void setTranslation(int i,const Vector &v) throw();

  ///
  void setRotation(int i,const Vector &v) throw();

  ///
  Triangle3D getTriangle(int i) const throw();

  ///
  Vector getOrigin(int i) const throw();

};

#endif



