/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class FlashPalette;

#ifndef __FlashPalette_h__
#define __FlashPalette_h__

#include "Ini.h"
#include "Walkable.h"
#include "WindowPipe.h"
#include "GraphicMode.h"

// sert pour l'option 'photo' et le debut

/**
   Used to put a white screen when photo.
   Attention : "grey" (gris) do not work ! (too slow)
   @see CaseId
   @see CaseOptionPhoto
   @see Grille
   @author David FAUTHOUX
 */
class FlashPalette:public Walkable {
 protected:
  ///
  UnderMaskMatrix underMask;
  ///
  PixelMatrix pixelMatrix;
  ///
  Window windowFrom; 
  ///
  Window windowTo;
  ///
  WindowPipe windowPipe;

  ///
  enum IdFlash {
    ///
    FLASHING_TO_GRIS,
    ///
    FLASHING_TO_COLOR,
    ///
    NOT_FLASHING
  };
  ///
  bool flashing;
  ///
  IdFlash flashed;

  ///
  virtual int virtualWalk() throw();
 public:
  ///
  FlashPalette(Ini& ini,GraphicMode& graphicMode) throw();
  ///
  virtual ~FlashPalette() throw();
  ///
  virtual void flashToGris() throw();
  ///
  virtual void flashToColor() throw();
  ///
  virtual void flashToOther() throw();
  ///
  bool isGris() const throw();

  ///
  void refresh() throw();
};

#endif
