/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Font;

#ifndef __Font_h__
#define __Font_h__

#include "Ini.h"
#include "Array.h"
#include "Sprite.h"
#include "Tji.h"

/**
   A font contains 256 characters in the Sprite form.
   The file must contains the 256 characters in one line, so Font can recognize the width and the height of one character (see Character/font.gif)
   @see Strip
   @see StripContainer
   @see PixelMatrix
   @author David FAUTHOUX
 */
class Font {
 protected:
  ///
  Array< Sprite * > alphabet;
  ///
  Array< int > translation;
  ///
  Tji size;

  ///
  Pixel fontColor;
  ///
  Pixel backgroundColor;

  ///
  void setColor(Pixel oldFontColor) throw();
  ///
  void copyOther(const Font& font) throw();

 public:
  ///
  Font(Ini& ini) throw(Exception);

  ///
  Font(const Font& font,Pixel fontColor,Pixel backgroundColor) throw();
  ///
  Font(const Font& font,Pixel fontColor) throw();
  ///
  Font(const Font& font) throw();

  ///
  virtual ~Font() throw();

  ///
  virtual const Sprite *get(char c) const throw();
  ///
  virtual int nbLine() const throw();
  ///
  virtual int nbColumn() const throw();

  ///
  virtual Pixel getFontColor() const throw();
  ///
  virtual Pixel getBackgroundColor() const throw();

};

#endif
