/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class GifIn;

#ifndef __GifIn_h__
#define __GifIn_h__

#include <stdio.h>
#include "PictureIn.h"
#include "List.h"

#define GIF_NB_COLORS 256

/**
   Thanks to gimp sources : - Peter Mattis, Spencer Kimball, Adam Moss.
   Only load.
   @author David FAUTHOUX
 */
class GifIn:public PictureIn {
 private:
  int gif89disposal;
  int gif89inputFlag;
  int gif89delayTime;
  int gif89transparent;
  int ZeroDataBlock;
  int GetDataBlock (FILE *fd,unsigned char *buf);
  bool ReadColorMap (FILE *fd,int number,uchar  *buffer);
  bool DoExtension (FILE *fd,int label);
  int GetCode (FILE *fd,int code_size,int flag);
  int LWZReadByte (FILE *fd,int flag,int input_code_size);
  bool ReadImage (FILE *fd,uchar *cmap,int ncols,int interlace,int leftpos,int toppos,
		  int screenWidth,int screenHeight,Sprite& sprite,int jSize,int iSize);
  bool load_image (const char *filename);

  /*%%%%%%%%
  bool translucideColors[GIF_NB_COLORS];
  bool bonhommeColors[GIF_NB_COLORS];
  List< Pixel > *rgbBonhommeColors;
  List< Pixel > *getRgbBonhommeColors() throw();
  */

 public:
  ///
  GifIn(const String& nameFile) throw(Exception);

  ///
  virtual ~GifIn() throw() {}
};

#endif

