/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class GraphicMode;

#ifndef __GraphicMode_h__
#define __GraphicMode_h__

#include "PixelMatrix.h"
#include "List.h"
#include "Redirector.h"

// La derivation publique (Array2) permet d'acceder
// facilement ('[]') aux pixels

// On peut rediriger le refresh vers un Redirector
// qui peut regarder, sauvegarder, etc... le tableau.
// Il doit renvoyer un tableau qui sera affiche

/**
   Map PixelMatrix to the screen.
   The public inherit from PixelMatrix enables to use [ ] easily.
   Interesting : it can be "redirected" : the PixelMatrix is not mapped to the screen but to a Redirector, its return is so mapped to the screen.
   @see Redirector
   @author David FAUTHOUX
 */
class GraphicMode:public PixelMatrix {
 protected:
  ///
  List< Redirector * > redirector;
  ///
  bool actif;

  //%% protected:
  //%%  virtual void realRefresh(const Array2<Pixel>& a) throw()=0;

 public:
  ///
  GraphicMode(int gapBetweenLuz) throw ();

  ///
  virtual ~GraphicMode() throw ();

  //  virtual void waitRetrace() const throw ();

  ///
  virtual void on() throw (Exception);
  ///
  virtual void off() throw ();

  //  virtual bool isOn() const throw ();

  ///
  virtual void clear() throw ();

  ///
  void getSize(int& j,int& i) const throw ();


  //  /*final*/
  ///
  void refresh() throw ();

  //  /*final*/
  ///
  void redirect(Redirector& r) throw();
  //ajoute un Redirector (a la fin du tube de transmission de la sortie ecran)

  //%%  GraphicMode& operator=(const Array2< Pixel >& a) throw();
};

#endif



