/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Key;

#ifndef __Key_h__
#define __Key_h__

// a completer.

// Utilise par 'Keyer'

/**
   @see Keyer
   @see Keyable
   @author David FAUTHOUX
 */
class Key {
 public:
  ///
  enum Evenement {
    ///
    UP,
    ///
    DOWN
  };
 private:
  ///
  const int code;
  ///
  const Evenement evenement;
 public:
  ///
  static const int ENTER=28;
  ///
  static const int ESCAPE=1;
  ///
  static const int SPACE=57;

  ///
  static const int PAGE_UP=104;
  ///
  static const int PAGE_DOWN=109;

  ///
  static const int CURSOR_UP=103;
  ///
  static const int CURSOR_DOWN=108;
  ///
  static const int CURSOR_LEFT=105;
  ///
  static const int CURSOR_RIGHT=106;

  ///
  static const int SCROLL_LOCK=70;

  //for AZERTY keyboard
  ///
  static const int A=16;
  ///
  static const int Z=17;
  ///
  static const int E=18;
  ///
  static const int R=19;
  ///
  static const int T=20;
  ///
  static const int Y=21;
  ///
  static const int U=22;
  ///
  static const int I=23;
  ///
  static const int O=24;
  ///
  static const int P=25;

  ///
  static const int Q=30;
  ///
  static const int S=31;
  ///
  static const int D=32;
  ///
  static const int F=33;
  ///
  static const int G=34;
  ///
  static const int H=35;
  ///
  static const int J=36;
  ///
  static const int K=37;
  ///
  static const int L=38;
  ///
  static const int M=39;

  ///
  static const int W=44;
  ///
  static const int X=45;
  ///
  static const int C=46;
  ///
  static const int V=47;
  ///
  static const int B=48;
  ///
  static const int N=49;

  //...
  
  ///
  Key(int c,Evenement e) throw():code(c),evenement(e) {}
  ///
  ~Key() throw() {}
  ///Scancode (raw)
  int getCode() const throw() { return code; }
  ///If released
  bool isUp() const throw() { return (evenement==UP); }
  ///If pressed
  bool isDown() const throw() { return (evenement==DOWN); }
};

#endif
