/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class KeyboardBuffer;

#ifndef __KeyboardBuffer_h__
#define __KeyboardBuffer_h__

#include "Keyboard.h"
#include "Key.h"
#include "List.h"
#include "Fifo.h"

/**
   More powerful than Keyboard : it can send again a old key pressed if another has been pressed, so the game can manage easily the key action.
   If you press the #13 key without releasing it (the KeyboardBuffer sends #13 down), and you press the #1 key (the KeyboardBuffer sends #1 down), when you release the #1 key (the KeyboardBuffer sends #1 up), the KeyboardBuffer sends again #13 down. So the moving of the Bonhomme are cool !!
   @author David FAUTHOUX
 */
class KeyboardBuffer:public Keyboard {
 private:
  ///
  const /*  static */bool withoutRepeat;
  ///
  /*  static */Fifo<Key*> buf;
  ///
  /*  static */List<int> downList;
  ///
  /*  static */List<Key*> toBeDeleted;

  ///
  virtual void work(int key,bool press) throw();

  //  friend void keyInBuffer(int key,int press) throw();
 public:

  ///
  KeyboardBuffer(bool _withoutRepeat=true) throw (Exception);
  ///
  virtual ~KeyboardBuffer() throw();

  ///
  virtual Key *get() throw (); //doit etre deleted par l'appelant
};


#endif
