/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include <iostream.h>
#include "Keyer.h"

DefaultKeyable defaultKeyable;


Keyer::Keyer(bool _withoutRepeat) throw(Exception)
  :Walkable(0),keyboard(0),withoutRepeat(_withoutRepeat)
{
  //%%  keyboard=new KeyboardBuffer(withoutRepeat);
  //%  keyboardIn();
  add(defaultKeyable);
}

Keyer::~Keyer() throw()
{
  if(keyboard) delete keyboard;
  //%  keyboardOut();
}

/*
void Keyer::keyboardIn() throw(Exception)
{
  keyboard=new KeyboardBuffer(withoutRepeat);
}

void Keyer::keyboardOut() throw()
{
  delete keyboard;
  keyboard=0;
}
*/

void Keyer::add(Keyable& keyable) throw()
{
  list.put(&keyable);
}

int Keyer::virtualWalk() throw(Exception)
{
  if(!keyboard) keyboard=new KeyboardBuffer(withoutRepeat);

  keyboard->refresh();
  Key *k;
  while((k=keyboard->get())!=0) {
    list.place();
    while(list.walk()) list.get()->keyAction(*k);
    delete k;
  }
  return 1;
}
