/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Keyer;

#ifndef __Keyer_h__
#define __Keyer_h__

#include "KeyboardBuffer.h"
#include "Walkable.h"
#include "Keyable.h"
#include "DefaultKeyable.h"

// Container de 'Keyable', cette classe passe l'action 'KeyAction' a tous
// ses 'Keyable'.


extern DefaultKeyable defaultKeyable;

// Cette classe cree le keyboard.

/**
   Manages the key evenements. Creates a KeyboardBuffer, and sends key actions to its list of Keyable (added with add()).
   @author David FAUTHOUX
 */
class Keyer:public Walkable {
 protected:
  ///
  KeyboardBuffer *keyboard;
  ///
  List<Keyable *> list;
  ///
  bool withoutRepeat;//repetition des touches ?

  ///
  int virtual virtualWalk() throw(Exception);
 public:
  ///
  Keyer(bool _withoutRepeat=true) throw(Exception);
  ///
  virtual ~Keyer() throw();

  ///
  void virtual add(Keyable& keyable) throw();

  /*
  //activation/desactivation du clavier
  void keyboardIn() throw(Exception);
  void keyboardOut() throw();
  */
};


#endif
