/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "Leaver.h"
#include "Bonhomme20.h"
#include "Grille.h"

Leaver::Leaver(Bonhomme20& b,CaseId::Id c,Grille& grille) throw()
  :Walkable(0),bonhommeRef(&b),idC(c),grilleRef(&grille)
{
  int niv,j[4],i[4];
  bonhommeRef->getPosTolerantAction(niv,j,i);
  for(int k=0;k<4;k++) {
    pos[k].j=j[k];
    pos[k].i=i[k];
  }
}

Leaver::~Leaver() throw()
{
}

int Leaver::virtualWalk() throw()
{
  int niv,j[4],i[4];
  bonhommeRef->getPosTolerantAction(niv,j,i);
  for(int k=0;k<4;k++) {
    bool doIt=true;
    int t=0;
    while(t<4 && doIt) {
      if(pos[k].j==j[t] && pos[k].i==i[t]) doIt=false;
      t++;
    }
    if(doIt) //l'ancienne case differente de ttes les nouvelles
      grilleRef->add(idC,niv,pos[k].j,pos[k].i);
    //actualiser les cases "pos"
    pos[k].j=j[k];
    pos[k].i=i[k];
  }
  return 1;
}

CaseId::Id Leaver::getCase() const throw()
{
  return idC;
}
