/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Main;

#ifndef __Main_h__
#define __Main_h__

#include "Keyable.h"
#include "CounterContainer.h"
#include "Ini.h"
#include "GraphicMode.h"
#include "FlashPalette.h"
#include "PageChanger.h"
#include "Keyer.h"
#include "Sounder.h"
#include "Blower.h"
//%% #include "Signaler.h"
#include "TextPainter.h"
#include "StripContainer.h"
#include "MessageKeeper.h"

#include <time.h>
/*
addon:ScreenCopier
author:David FAUTHOUX
*/
//1 line added
#include "ScreenCopierRedirector.h"

///global execution class
class Main:public Walkable,public Keyable,public CounterContainer,public MessageKeeper {
 protected:
  ///Used with MessageKeeper
  enum MessageEnum {
    ///
    MESSAGE_LINUX,
    ///
    MESSAGE_HELP
  
/*
addon:AddMusicOffCommandInMain
author:David FAUTHOUX
*/
//3 lines added
/**
*/
,MESSAGE_MusicOff
/*
addon:AddMusicOnCommandInMain
author:David FAUTHOUX
*/
//3 lines added
/**
*/
,MESSAGE_MusicOn
};

  ///Will clean the .ini files
  bool clean;

  ///
  clock_t incCptClock;
  ///
  clock_t nextCptClock;

  ///key managed by the class to stop the game at once
  int keyHalt;

  //key managed by the class to view the game speed with the border color (vertical retrace)
    //  int keyVbl;

  ///
  bool halted;


  ///
  bool ok;

  ///The Keyer of the game
  Keyer *keyer;

  //%% /the Signaler of the game
  //%%  Signaler *signaler;

  ///A Blower for the game
  Blower *blower;
  ///The PageChanger of the game
  PageChanger *pageChanger;
  ///The GraphicMode of the game
  GraphicMode *graphicMode;
  ///The FlashPalette of the game
  FlashPalette *palette;
  ///The Sounder of the game
  Sounder *sounder;
  ///The Ini of the game
  Ini *ini;

  ///The TextPainter of the game
  TextPainter *textPainter;

  ///The StripContainer of the game
  StripContainer *stripContainer;


  ///Name of the .ini file
  const char *const nameFile;

  ///Used with Sounder
  int soundMusik;
  ///
  int timeWaitMusik;
  ///
  int timeScreen;

  ///Used with MessageKeeper
  List< const String * > *linuxMessage;

  ///
  void endOfCount(int value) throw();
  ///
  int virtualWalk() throw();
  ///
  void action(int id) throw();
 public:
  ///
  Main(const char *nameFileIni,bool willClean) throw();
  ///
  virtual ~Main() throw();

  ///The Keyer calls keyAction() of its elements, Main is an element of Keyer
  virtual void keyAction(const Key& key) throw();

  //%%  virtual void signalAction(int idSignal) throw();

  ///Useless ? Because the game use clock() to synchronize speed
  virtual void setSlow(int slow) throw();




















/*
addon:AddSetMusikVolumeInMain
author:David FAUTHOUX
*/
//5 lines added
public:
/**
Sets the musik volume to 0
*/
virtual void switchOffMusikBySettingVolumeTo0() throw();
/*
addon:AddSetMusikVolumeInMain
author:David FAUTHOUX
*/
//5 lines added
public:
/**
Sets the musik volume to 0
*/
virtual void switchOnMusikBySettingVolumeToNormal() throw();
/*
addon:AddSetMusikVolumeInMain
author:David FAUTHOUX
*/
//5 lines added
protected:
/**
Saves the initial volume of musik
*/
int musikNormalVolume;
/*
addon:AddMusicOffCommandInMain
author:David FAUTHOUX
*/
//4 lines added
protected:
/**
*/
String messageMusicOff;
/*
addon:AddMusicOnCommandInMain
author:David FAUTHOUX
*/
//4 lines added
protected:
/**
*/
String messageMusicOn;
/*
addon:ScreenCopier
author:David FAUTHOUX
*/
//4 lines added
protected:
/**
*/
ScreenCopierRedirector * redirectorScreenCopier;
};


#endif
