/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



/*
  Code of my friend Ulrich ROISSARD - 1999
 */

class Matrice;

#ifndef __Matrice_h__
#define __Matrice_h__

#include <iostream.h>
#include "Vector.h"

///
class Matrice {
protected:
  ///
  float mat[4][4];
public:
  ///
  Matrice() {
    setNull();
  }

  ///
  ~Matrice() throw() {}

  ///
  Matrice(const Matrice &m) {
    for (int i=0;i<4;i++)
      for (int j=0;j<4;j++)
	mat[i][j]=m.mat[i][j];
  }

  ///
  Matrice &setNull() {
    for (int i=0;i<4;i++)
      for (int j=0;j<4;j++)
	mat[i][j]=0;
    return *this;
  }

  ///
  Matrice &setIdentity() {
    setNull();
    for (int i=0;i<4;i++)
      mat[i][i]=1;
    return *this;
  }

  ///
  float &get(int s,int t) {
    return mat[s][t];
  }

  ///
  float get(int s,int t) const {
    return mat[s][t];
  }

  /*
  ///
  Matrice &operator=(const Matrice &m) {
    for (int i=0;i<4;i++)
      mat[i]=m.mat[i];
    return *this;
  }

  ///
  bool operator==(const Matrice &m) const {
    for (int i=0;i<4;i++)
      if (mat[i]!=m.mat[i])
        return false;
    return true;
  }

  ///
  bool operator!=(const Matrice &m) const {
    for (int i=0;i<4;i++)
      if (mat[i]==m.mat[i])
        return false;
    return true;
  }

  ///
  Matrice operator+(const Matrice &m) const {
    Matrice tmp;
    for (int i=0;i<4;i++)
      tmp.mat[i]=mat[i]+m.mat[i];
    return tmp;
  }

  ///
  Matrice operator-() const {
    Matrice tmp;
    for (int i=0;i<4;i++)
      tmp.mat[i]=-mat[i];
    return tmp;
  }

  ///
  Matrice operator-(const Matrice &m) const {
    Matrice tmp;
    for (int i=0;i<4;i++)
      tmp->mat[i]=mat[i]-m.mat[i];
    return tmp;
  }
  */

  ///
  Matrice operator*(const Matrice &m) const {
    Matrice tmp;
    for (int i=0;i<4;i++)
      for (int j=0;j<4;j++) {
    	float tIJ=0;
    	for (int k=0;k<4;k++)
    	  tIJ+=mat[i][k]*m.mat[k][j];
    	tmp.mat[i][j]=tIJ;
      }
    return tmp;
  }
  
  ///
  Vector operator*(const Vector &v) const {
    Vector tmp;
    for (int i=0;i<3;i++) {
      Vector tmp2(mat[i][0],mat[i][1],mat[i][2]);
      tmp[i]=tmp2*v;
    }
    Vector tmp2(mat[0][3],mat[1][3],mat[2][3]);
    tmp=tmp+tmp2;
    return tmp;
  }

  /*
  ///
  Matrice operator*(float v) const {
    Matrice tmp;
    for (int i=0;i<4;i++)
      tmp.mat[i]=mat[i]*v;
    return tmp;
  }

  ///
  Matrice operator/(float v) const {
    Matrice tmp;
    for (int i=0;i<4;i++)
      tmp.mat[i]=mat[i]/v;
    return tmp;
  }
 
  ///
  friend Matrice operator*(float f,Matrice &v) {
    return v*f;
  }

  ///
  friend Matrice operator/(float f,Matrice &v) {
    return v/f;
  }
  */
  ///
  friend Matrice nullMatrice() {
    return Matrice();
  }

  ///
  friend Matrice identityMatrice() {
    Matrice m;
    m.setIdentity();
    return m;
  }

  /*    
  ///
  friend ostream &operator<<(ostream &os,Matrice &m) {
    os << "(";
    for (int i=0;i<4-1;i++)
      os << m.mat[i] << ",";
    return os << m.mat[4-1] << ")";
  }
  */
};


#include "Matrice.cc"
//useless

#endif
