/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "MessageKeeper.h"

MessageKeeper::MessageKeeper() throw()
{
}

MessageKeeper::~MessageKeeper() throw()
{
  list.place();
  while(list.walk()) delete list.get();
}

void MessageKeeper::incContained(Tcontained *c) throw(Exception)
{
  if(!c->mot.walk()) {
    c->mot.place();
    c->mot.walk();
    action(c->idAction);
  }
}
  
void MessageKeeper::work(const Key& key) throw(Exception)
{
  if(key.isDown()) return;
  int k=key.getCode();
  list.place();
  while(list.walk()) {
    Tcontained *c=list.get();
    if(c->mot.get()==k) incContained(c);
    else {
      c->mot.place();
      c->mot.walk();
      if(c->mot.get()==k) incContained(c);
    }
  }
}
 
void MessageKeeper::message(List< int >& listKey,int idAction) throw()
{
  Tcontained *c=new Tcontained(listKey,idAction);
  list.place();
  list.put(c);
}

