/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "MoreMultiAnim.h"
#include "error.h"

MoreMultiAnim::MoreMultiAnim() throw()
{
}

MoreMultiAnim::~MoreMultiAnim() throw()
{
}

void MoreMultiAnim::paint(WindowPipe& windowPipe) throw()
{
  MultiAnim::paint(windowPipe);
  animOnMore.place();
  while(animOnMore.walk()) {
    Anim *a=animOnMore.get();
    if(a->isActive())
      a->paint(windowPipe);
  }
}

void MoreMultiAnim::paintNight(WindowPipe& windowPipe) throw()
{
  MultiAnim::paintNight(windowPipe);
  animOnMore.place();
  while(animOnMore.walk()) {
    Anim *a=animOnMore.get();
    if(a->isActive())
      a->paintNight(windowPipe);
  }
}

int MoreMultiAnim::virtualWalk() throw()
{
  animOnMore.place();
  while(animOnMore.walk()) {
    Anim *a=animOnMore.get();
    if(a->isActive())
      if(!a->walk()) animOnMore.suppr();
  }
  
  return MultiAnim::virtualWalk();
}

void MoreMultiAnim::reinit() throw()
{
  animOnMore.place();
  while(animOnMore.walk()) animOnMore.suppr();
  MultiAnim::reinit();
}

void MoreMultiAnim::onMore(int id) throw (Exception)
{
  if(id<0 || id>=length) throw Exception(ERROR_MOREMULTIANIM_INVALID_ID);
  supprMore(id);
  Anim *a=tab[id];
  animOnMore.place();
  animOnMore.put(a);
  a->reinit();
}

void MoreMultiAnim::supprMore(int id) throw (Exception)
{
  if(id<0 || id>=length) throw Exception(ERROR_MOREMULTIANIM_INVALID_ID);
  Anim *a=tab[id];
  animOnMore.place();
  while(animOnMore.walk())
    if(animOnMore.get()==a) {
      animOnMore.suppr();
      return;
    }
}

bool MoreMultiAnim::isOn(int id) throw ()
{
  if(id<0 || id>=length) return false;
  Anim *a=tab[id];
  animOnMore.place();
  while(animOnMore.walk())
    if(animOnMore.get()==a) return true;
  return false;
}

