/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Page;

#ifndef __Page_h__
#define __Page_h__

#include "Painter.h"
#include "Ini.h"
#include "Key.h"
#include "Sounder.h"
#include "StripContainer.h"
#include "List.h"
#include "MessageKeeper.h"


/**
   Manages a Background and all the Pageable on it : all the animations, but also all the other Pageable (Mot, BonhommeContainer...)
   @author David FAUTHOUX
 */
class Page:public Painter,public MessageKeeper {
 protected:
  ///Used with MessageKeeper
  enum MessageEnum {
    NO_MESSAGE
  
};

  ///
  Sounder *const sounderRef;
  ///
  StripContainer *const stripContainerRef;
  ///
  const int soundBlowUpId;
  ///
  bool totalyGone;

  ///
  List< const String * > *stripList;

  ///
  virtual void action(int idAction) throw();

  ///
  virtual int virtualWalk() throw();

 public:
  ///
  Page(Ini& ini,int numeroSection,GraphicMode& graphicMode,
       Sounder& sounder,int soundBlowUpMotId,
       StripContainer& stripContainer) throw(Exception);

  ///
  virtual ~Page() throw();
  ///
  void virtual keyAction(const Key& key) throw();

  ///Called by PageChanger when Page chosen
  void virtual reinit() throw();
  ///Used by PageChanger
  void virtual setTotalyGone() throw();
  ///Return true if the PageChanger for example has called setTotalyGone
  bool virtual isTotalyGone() const throw();

  ///Used by PageChanger
  void virtual goOut() throw();

};

#endif
