/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class PageBonhomme;

#ifndef __PageBonhomme_h__
#define __PageBonhomme_h__

#include "Page.h"
#include "Ini.h"
#include "BonhommeContainer.h"

/**
   Choice of the Bonhommmes
   @author David FAUTHOUX
 */
class PageBonhomme:public Page {
 protected:
  ///
  BonhommeContainer *const bonhommeContainerRef;
  
  ///
  int virtualWalk() throw();
 public:
  ///
  PageBonhomme(Ini& ini,int numeroSection,GraphicMode& graphicMode,
	       BonhommeContainer& bonhommeContainer,
	       Sounder& sounder,int soundBlowMotId,
	       StripContainer& stripContainer) throw(Exception);
  ///
  virtual ~PageBonhomme() throw();
  ///
  void paint() throw();
  ///
  void reinit() throw();
  ///
  void keyAction(const Key& key) throw();
};

#endif
