/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "PageChangerCouple.h"


PageChangerCouple::PageChangerCouple(Page *p,const String& i) throw():page(p),id(&i)
{
}

PageChangerCouple::~PageChangerCouple() throw()
{
  list.place();
  while(list.walk()) delete list.get();
}

void PageChangerCouple::add(int k,Page *p) throw()
{
  list.put(new PageChangerCorresp(k,p));
}

const String *PageChangerCouple::getId() const throw()
{
  return id;
}

Page *PageChangerCouple::getPage() throw()
{
  return page;
}

bool PageChangerCouple::getCorresp(int key,Page *& p) throw()
{
  list.place();
  while(list.walk())
    if(list.get()->getKey()==key) {
      p=list.get()->getPage();
      return true;
    }
  return false;
}

