/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class PageChangerCouple;

#ifndef __PageChangerCouple_h__
#define __PageChangerCouple_h__

#include "Page.h"
#include "String.h"
#include "PageChangerCorresp.h"

/**
   Links id and PageChangerCorresp with Page
   @see PageChangerCorresp
   @see PageChanger
   @author David FAUTHOUX
 */
class PageChangerCouple {
  ///
  Page *const page;
  ///
  const String *const id;
    ///
  List< PageChangerCorresp * > list;
 public:
    ///
  PageChangerCouple(Page *p,const String& i) throw();
  ///
  ~PageChangerCouple() throw();
  ///
  void add(int k,Page *p) throw();
  ///
  const String *getId() const throw();
  ///
  Page *getPage() throw();
  ///
  bool getCorresp(int key,Page *& p) throw(); //true=>found
};

#endif
