/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class PageChoiceFond;

#ifndef __PageChoiceFond_h__
#define __PageChoiceFond_h__

#include "Page.h"
#include "Ini.h"
#include "PageGame.h"
#include "Mot.h"

// Classe fortement associe a 'PageGame', c'est cette classe qui modifie le
// plateau de jeu.

/**
   This class is hardly hung with PageGame because it asks the load of the game, according to the choice.
   @author David FAUTHOUX
 */
class PageChoiceFond:public Page {
 protected:
  ///
  PageGame *pageGameRef;
  ///
  Ini *const iniRef;
  ///
  int numeroSectionRef;
  ///
  int keyAccept,keyLeft,keyRight;
  ///
  List< Mot * > listMotFond;
  ///
  List< int > listSoundFond;
  ///
  int currentFond;
  ///
  int nbFond;
 public:
  ///
  PageChoiceFond(Ini& ini,int numeroSection,GraphicMode& graphicMode,
		 Sounder& sounder,int soundBlowMotId,
		 StripContainer& stripContainer) throw(Exception);
  ///
  void setPageGame(PageGame& pageGame,bool loadAll) throw(Exception);
  ///
  virtual ~PageChoiceFond() throw();
  ///
  void keyAction(const Key& key) throw(Exception);
};

#endif
