/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "PageScore.h"

PageScore::PageScore(Ini& ini,int numeroSection,
		     GraphicMode& graphicMode,
		     BonhommeContainer& bonhommeContainer,
		     Sounder& sounder,int soundBlowMotId,
		     StripContainer& stripContainer)
  throw(Exception)
  :Page(ini,numeroSection,graphicMode,sounder,soundBlowMotId,stripContainer),
   bonhommeContainerRef(&bonhommeContainer)
{
}

PageScore::~PageScore() throw()
{
}

int PageScore::virtualWalk() throw()
{
  List<Player*> *l=bonhommeContainerRef->getPlayerPlaying();
  l->place();
  while(l->walk()) l->get()->getScore()->walk();
  return Page::virtualWalk();
}

void PageScore::reinit() throw()
{
  List<Player*> *l=bonhommeContainerRef->getPlayerPlaying();
  l->place();
  while(l->walk()) l->get()->getScore()->reinit();
  Page::reinit();
}

void PageScore::paint() throw()
{
  Page::paint();
  List<Player*> *l=bonhommeContainerRef->getPlayerPlaying();
  l->place();
  while(l->walk())
    l->get()->getScore()->paint(*(background->getWindowPipe()));
}
