/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "Painter.h"

Painter::Painter(Background& back,int slow) throw()
  :PageableContainer(slow),background(&back)
{
  moveOnScreen(0,0);
  scroll(0,0);
}

Painter::~Painter() throw()
{
  delete background;
}

void Painter::setBackground(Background& back) throw()
{
  delete background;
  background=&back;
  moveOnScreen(0,0);
  scroll(0,0);
}

//void Painter::paint(WindowPipe< Pixel >& windowPipe) throw(Exception) //INTERDIT
//{
  //  throw Exception(ERROR_CODE);
//}

void Painter::paint() throw()
{
  background->paint();
  list.place();
  while(list.walk()) {
    if(list.get()->isActive())
      list.get()->paint(*(background->getWindowPipe()));
  }
}

void Painter::moveOnScreen(int j,int i) throw()
{
  posOnScreen.j=j;
  posOnScreen.i=i;
  background->getWindowPipe()->moveTo(j,i);
}

void Painter::getPosOnScreen(int& j,int& i) const throw()
{
  j=posOnScreen.j;
  i=posOnScreen.i;
}

void Painter::scroll(int j,int i) throw()
{
  background->getWindowPipe()->moveFrom(j,i);
}
