/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class PictureIn;

#ifndef __PictureIn_h__
#define __PictureIn_h__

#include "Sprite.h"
#include "List.h"

/**
   Load a file with layers, and put layers in a list (in Sprite form). Must be inherited.
   @see GifIn
   @author David FAUTHOUX
 */
class PictureIn {
 protected:
  ///
  List< Sprite * > list;

 public:
  ///Here does nothing, must be inherited using list and Sprite concept.
  PictureIn() throw() {}//a surcharger : loader le fichier
  ///Destroy the list in inherited class !
  virtual ~PictureIn() throw() {}

  ///Walks on the Sprite list
  virtual int walk() throw() { return list.walk(); } //return 0 si a la fin
  ///Places on the begin of the Sprite list
  virtual void place() throw() { list.place(); } //place au debut de la liste de bitmap

  ///Returns the current Sprite
  virtual Sprite *get() const throw(Exception) { return list.get(); }//exception si a la fin de la liste

};

#endif
