/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "Pixel.h"

PixelPalette *pixelPalette=0;
PixelPalette *pixelGreyPalette=0;
bool pixelGrey=false;

bool enablePixelPalette(int gapBetweenLuz) throw()
{
  pixelGrey=false;

  if(!pixelPalette)
    pixelPalette=new PixelPalette;//[2*PIXEL_NUMBER_OF_COLOR];
  if(pixelPalette==0) return false;

  if(!pixelGreyPalette)
    pixelGreyPalette=new PixelPalette;//[2*PIXEL_NUMBER_OF_COLOR];
  if(pixelGreyPalette==0) return false;

  for(int n=0;n<2;n++)
    for(int k=n*PIXEL_NUMBER_OF_COLOR;k<(n+1)*PIXEL_NUMBER_OF_COLOR;k++) {
      int r=getRedFromPixel(k);
      int g=getGreenFromPixel(k);
      int b=getBlueFromPixel(k);

      int grey=(r+g+b)/3;

      r+=gapBetweenLuz*n;
      g+=gapBetweenLuz*n;
      b+=gapBetweenLuz*n;

      if(r<minRedValue) r=minRedValue;
      if(g<minGreenValue) g=minGreenValue;
      if(b<minBlueValue) b=minBlueValue;

      if(r>maxRedValue) r=maxRedValue;
      if(g>maxGreenValue) g=maxGreenValue;
      if(b>maxBlueValue) b=maxBlueValue;

      //      if(grey<minGreyValue) grey=minGreyValue;
      //      if(grey>maxGreyValue) grey=maxGreyValue;

      //      (*pixelPalette)[k]=(toPixel(r,g,b,n) & 0x7fff);
      //      (*pixelGreyPalette)[k]=(toPixel(grey,grey,grey,n) & 0x7fff);
      (*pixelPalette)[k]=toPhysicPixel(r,g,b);
      (*pixelGreyPalette)[k]=toPhysicPixel(grey,grey,grey);
    }

  return true;
}

void disablePixelPalette() throw()
{
  if(pixelPalette) delete pixelPalette;
  if(pixelGreyPalette) delete pixelGreyPalette;
}
