/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "PixelArray.h"
#include "mem_function.h"

PixelArray::PixelArray(Pixel *ref,int size) throw()
  :Array<Pixel>(ref,size)
{
}

void 
PixelArray::
copy(const PixelArray& a,
     int posFrom,int posTo,int sizeFrom) throw()
{
  memCopy(a.p+posFrom,p+posTo,sizeFrom);
}

void 
PixelArray::
putSprite(const PixelArray& a,const PixelArray& mask,
	  int posFrom,int posTo,int sizeFrom) throw()
{
  memPutSprite(a.p+posFrom,mask.p+posFrom,p+posTo,sizeFrom);
}

void 
PixelArray::
putSpriteColor(Pixel color,const PixelArray& a,
	       int posFrom,int posTo,int sizeFrom) throw()
{
  memPutSpriteColor(color,a.p+posFrom,p+posTo,sizeFrom);
}

void 
PixelArray::
putSpriteUnderMask(const PixelArray& a,const PixelArray& mask,
		   int posFrom,int posTo,int sizeFrom,
		   const UnderMaskArray& underMask,int posUnderMask) throw()
{
  memPutSpriteUnderMask(a.p+posFrom,mask.p+posFrom,p+posTo,
			(const unsigned char *)underMask+posUnderMask,
			sizeFrom);
}

void 
PixelArray::
putSpriteUnderMaskPalette(const PixelArray& a,const PixelArray& mask,
			  int posFrom,int posTo,int sizeFrom,
			  const UnderMaskArray& underMask,int posUnderMask,
			  const PixelPalette& pal) throw()
{
  memPutSpriteUnderMaskPalette(a.p+posFrom,mask.p+posFrom,p+posTo,
			       (const unsigned char *)underMask+posUnderMask,
			       sizeFrom,
			       pal);
}



PixelArray&
PixelArray::
operator=(Pixel pixel) throw()
{
  memSet(p,pixel,s);
  return *this;
}

