/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Player;

#ifndef __Player_h__
#define __Player_h__

#include "Score.h"
#include "Bonhomme.h"
#include "Grille.h"
#include "Key.h"
#include "Pageable.h"
#include "String.h"
#include "Tji.h"

// un 'Player' gere les touches et la couleur.
// il associe la couleur au bonhomme choisi (et a l'equipe).
// il gere un 'Score' associe a 'PageScore'.

/**
   Manages keys, Bonhomme color and Score.
   It associates the color to its Bonhomme and to its team's Bonhommes.
   @author David FAUTHOUX
 */
class Player:public Keyable {
 protected:
  ///
  Score *score;//=0
  ///
  Tji posScore;
  ///Up, down, left, right, fire, special fire
  int key[6];
  ///
  Pixel color;
  ///
  Bonhomme *bonhomme;//=0
  ///
  const String *idBonhomme;
  ///
  Ini *const iniRef;
  ///
  const int numeroSectionRef;
  ///Used to color the team
  int decColorTeam;


 public:
  ///
  Player(Ini& ini,int numeroSection) throw (Exception);
  ///
  virtual ~Player() throw(); //set dans .ini

  ///
  void keyAction(const Key& key) throw();

  ///
  void setBonhomme(Bonhomme& b) throw(); //cree un score
  ///
  Bonhomme *getBonhomme() throw();

  ///
  void setColorToBonhomme() throw();

  ///
  Score *getScore() throw();//pour pageScore
  ///
  void resetScore() throw();
  ///
  void incScore() throw();

  ///
  int getKeyUp() const throw();
  ///
  int getKeyDown() const throw();
  ///
  int getKeyLeft() const throw();
  ///
  int getKeyRight() const throw();
  ///
  int getKeyFire0() const throw();
  ///
  int getKeyFire1() const throw();

  ///
  void setKey(int k,int code) throw();

};

#endif
