/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class PreStrip;

#ifndef __PreStrip_h__
#define __PreStrip_h__

#include "String.h"
#include "Array.h"
#include "Ini.h"

/**
   Pre-calculate Strip, to be fast in the game.
   Used a lot by the CaseOption...
   @see Strip
   @author David FAUTHOUX
 */
class PreStrip {
 public:
  ///
  enum Id {
    ///
    CASE_MINE=0,
    ///
    CASE_OPTION_BOMBE,
    ///
    CASE_OPTION_FLAMME,
    ///
    CASE_OPTION_OUBA,
    ///
    CASE_OPTION_ARMAGEDDON,
    ///
    CASE_OPTION_CHICKEN,
    ///
    CASE_OPTION_PHOTO,
    ///
    CASE_OPTION_FEU_CUL,
    ///
    CASE_OPTION_SUPER_BOMBE,
    ///
    CASE_OPTION_MINE,
    ///
    CASE_OPTION_DYNAMITE,
    ///
    CASE_OPTION_INVINCIBLE,
    ///
    CASE_OPTION_INVISIBLE,
    ///
    CASE_OPTION_POSE_MUR,
    ///
    CASE_OPTION_SURPUISSANCE,
    ///
    CASE_OPTION_WIN95,
    ///
    CASE_OPTION_TRAVERSE_MUR,
    ///
    CASE_OPTION_FEMME,
    ///
    CASE_OPTION_TELEPORT,
    ///
    CASE_OPTION_RESURRECT,
    ///
    CASE_OPTION_SPEED,
    ///
    NB_ID
  };
 protected:
  ///
  Array< const String * > strip;
 public:
  ///
  PreStrip(Ini& ini) throw();
  ///
  virtual ~PreStrip() throw();
  ///
  virtual const String *get(Id id) const throw();
};

#endif
