/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Redirector;

#ifndef __Redirector_h__
#define __Redirector_h__

#include "PixelMatrix.h"
#include "Walkable.h"

/**
   The GraphicMode can be redirect : instead of painted directly to the screen, the PixelMatrix can pass here.
   @see Blower
   @see GraphicMode
   @see PixelMatrix
   @author David FAUTHOUX
 */
class Redirector:public Walkable {
 public:
  /**
     "slow" is used to slow the call to virtualWalk().
     @see Walkable
  */
  Redirector(int slow);
  ///
  virtual ~Redirector();

  ///Return here wichever matrix you want (prefer the same size of "from"), this matrix will be used instead of "from" by GraphicMode
  virtual PixelMatrix *pipeIt(PixelMatrix& from) throw();

  //renvoie un tableau a afficher
};

#endif

