/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include <iostream.h>
#include "TextMode.h"
#include "display.h"

#define ESC (char)27

TextMode::TextMode() throw ()
  :actif(false)//,old(vga_getcurrentmode())
{
}

TextMode::~TextMode() throw ()
{
  if(actif) off();
}

void TextMode::refresh() throw ()
{
  if(actif) cout.flush();
}

void TextMode::on() throw ()
{
  if(actif) return;
  disableGraphic();
  //  vga_setmode(TEXT);
  actif=true;
  saveState();
}

bool TextMode::isOn() const throw ()
{
  return actif;
}

void TextMode::off() throw ()
{
  if(!actif) return;
  actif=false;
  restoreState();
  clear();
  refresh();
  enableGraphic();
  //  vga_setmode(old);
}

void TextMode::clear() throw ()
{
  cout<<ESC<<"[2J";
}

void TextMode::setForegroundColor(ColorId color) throw()
{
  String *s=new String((int)color+30);
  cout<<ESC<<"["<<(const char*)(*s)<<"m";
  delete s;
}

void TextMode::setBackgroundColor(ColorId color) throw()
{
  String *s=new String((int)color+40);
  cout<<ESC<<"["<<(const char*)(*s)<<"m";
  delete s;
}

void TextMode::goTo(int j,int i) throw()
{
  String *sj=new String(j);
  String *si=new String(i);
  cout<<ESC<<"["<<(const char*)(*sj)<<";"<<(const char*)(*si)<<"f";
  delete sj;
  delete si;
}

void TextMode::saveState() throw()
{
  cout<<ESC<<"7";
}

void TextMode::restoreState() throw()
{
  cout<<ESC<<"8";
}

void TextMode::setBold() throw()
{
  cout<<ESC<<"[1m";
}

void TextMode::unsetBold() throw()
{
  cout<<ESC<<"[22m";
}

void TextMode::print(const String& s) throw()
{
  cout<<(const char*)s;
}

void TextMode::newLine() throw()
{
  cout<<"\n";
}
