/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "TextPainter.h"


TextPainter::TextPainter(Ini& ini) throw(Exception)
{
  list.put(new Font(ini));
  defaultFont=list.get();
}


TextPainter::~TextPainter() throw()
{
  list.place();
  while(list.walk()) delete list.get();
}

void TextPainter::paint(WindowPipe& windowPipe,int j,int i,const String& text,const Font& font,bool to) throw()
{
  int iPos=i;
  for(int k=0;k<text.size();k++) {
    if(to) windowPipe.putTo(*font.get(text[k]),j,iPos,false);
    else windowPipe.put(*font.get(text[k]),j,iPos);
    iPos+=defaultFont->nbColumn();
  }
}

void TextPainter::paint(WindowPipe& windowPipe,int j,int i,const String& text,Pixel fontColor,Pixel backgroundColor,bool to) throw()
{
  list.place();
  while(list.walk()) {
    Font *f=list.get();
    if(f->getFontColor()==fontColor && f->getBackgroundColor()==backgroundColor) {
      paint(windowPipe,j,i,text,*f,to);
      return;
    }
  }
  //
  list.put(new Font(*defaultFont,fontColor,backgroundColor));
  paint(windowPipe,j,i,text,*list.get(),to);
}

void TextPainter::paint(WindowPipe& windowPipe,int j,int i,const String& text,Pixel fontColor,bool to) throw()
{
  paint(windowPipe,j,i,text,fontColor,defaultFont->getBackgroundColor(),to);
}

void TextPainter::paint(WindowPipe& windowPipe,int j,int i,const String& text,bool to) throw()
{
  paint(windowPipe,j,i,text,defaultFont->getFontColor(),defaultFont->getBackgroundColor(),to);
}


