/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Trembleur;

#ifndef __Trembleur_h__
#define __Trembleur_h__

#include "Walkable.h"
#include "Reinitable.h"
#include "Tensionable.h"

// fait trembler l'ecran (qui correspond a la 'Window' appele 'to',
// opposition a 'from').
// cf 'WindowPipe'

/**
   Used to shake the screen.
   @see Grille
   @see PageGame
   @see Trou
   @author David FAUTHOUX
 */
class Trembleur:public Walkable,public Reinitable {
 protected:
  ///
  Tensionable *tensionableRef;
  ///
  int j;
  ///
  int i;
  ///
  virtual int virtualWalk() throw();
 public:
  ///if tensionable null, no action on Tensionable, else tensionable.incTension
  Trembleur(Tensionable *tensionable) throw();
  ///
  virtual ~Trembleur() throw();
  ///
  virtual void reinit() throw();
  ///
  virtual void inc(int j,int i) throw();
  ///
  virtual void get(int& j,int& i) const throw();
};

#endif
