/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class UnderMaskMatrix;

#ifndef __UnderMaskMatrix_h__
#define __UnderMaskMatrix_h__

#include "UnderMaskArray.h"
#include "Pixel.h"

/**
   Used by Background and "mem_function cc" : it defines where the Sprite are painted (=1) and not (=0).
   @see Background
   @author David FAUTHOUX
 */
class UnderMaskMatrix {
 protected:
  ///
  Array< UnderMaskArray * > a;
  ///
  unsigned char *p;
 public:
  ///
  UnderMaskMatrix(int nbLine_j,int nbColumn_i) throw ();
  ///
  virtual ~UnderMaskMatrix() throw ();

  ///
  UnderMaskArray& operator[](int k) throw ();
  ///
  const UnderMaskArray& operator[](int k) const throw ();
  ///Vertical
  int nbLine() const throw();
  ///Horizontal
  int nbColumn() const throw();

  ///
  operator unsigned char*() const throw () { return p; }

};


#endif
