/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "AddOnScriptAnalyser.h"

void error(const char *argv0)
{
  cerr<<"This program enable you to add code automatically in c++ sources, and remove it easily.\n";
  cerr<<"Your sources must obey to several conventions (see Convention.h and Convention.cc).\n";
  cerr<<"Usage:"<<argv0<<" --add scriptToAdd || --remove scriptToRemove || --list\n";
  cerr.flush();
  exit(1);
}


int main(int argc,char *argv[])
{
  if(argc<=1) error(argv[0]);
  try {
    int k=1;
    bool verbose=false;
    while(k<argc) {
      if(*new String(argv[k])=="--list") {
	AddOnScriptAnalyser::listAddons();
      }
      else
	if(*new String(argv[k])=="--add") {
	  k++;
	  if(k<argc) {
	    AddOnScriptAnalyser f(argv[k],verbose);
	    f.analyse();
	  }
	  else error(argv[0]);
	}
	else
	  if(*new String(argv[k])=="--remove") {
	    k++;
	    if(k<argc) {
	      AddOnScriptAnalyser f(argv[k],verbose);
	      f.suppress();
	    }
	    else error(argv[0]);
	  }
	  else
	    if(*new String(argv[k])=="--verbose") {
	      verbose=true;
	    }
	    else { //error(argv[0]);
	      AddOnScriptAnalyser f(argv[k],verbose);
	      f.analyse();
	    }
      k++;
    }
    return 0;
  } catch(Exception) {
    cerr<<"Exception received, stop.\n";
    cerr.flush();
    return 1;
  }
}

