/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#ifndef __display_h__
#define __display_h__

#include "Pixel.h"
#include "String.h"

//You can create another display than Svgalib by creating a .c file defining this functions

bool enableKeyboard();
void disableKeyboard();
void getKeyboardCode(int& code,bool& pressed);//-1 if nothing
bool keyboardRefresh();

//BEFORE enableGraphic CALL enablePixelPalette() !! because it uses passPalette 
//ATTENTION : must switch on graphicMode with PIXEL_NUMBER_OF_COLOR colors
bool enableGraphic();

//AFTER disableGraphic you should call disablePixelPalette()
void disableGraphic();
int graphicWidth();
int graphicHeight();
void graphicRefresh(const Pixel *buffer); //buffer size=sizeof(Pixel)*graphicWitdth()*graphicHeight();


//sound
bool enableSound(int sampleRate,int nbChannel,const String& pathDsp) throw();
void disableSound() throw();
int addSoundFile(const String& nameFile) throw();//return the id
void supprSound(int id) throw();

void playSound(int id,int channel) throw();
void setVolumeSound(int id,int volume) throw();
void stopSoundChannel(int channel) throw();


#endif
