/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "display.h"
#include "List.h"
#include "soundHim.h"

#define MAX_NB_SOUND 1000
List< int > libre;

bool enableSound(int sampleRate,int nbChannel,const String& pathDsp) throw()
{
  if(Snd_init(MAX_NB_SOUND,sampleRate,nbChannel,pathDsp)==EXIT_FAILURE) return false;
  for(int k=0;k<MAX_NB_SOUND;k++) libre.put(k);
  return true;
}

void disableSound() throw()
{
  Snd_restore();
}

int addSoundFile(const String& nameFile) throw()
{
  libre.place();
  if(!libre.walk()) {
    cerr<<ERROR_NO_PLACE_FOR_NEW_SOUND;
    return -1;
  }
  int i=libre.get();
  libre.suppr();

  Snd_add((const char*)(nameFile),i);
  return i;
}

void supprSound(int id) throw()
{
  libre.put(id);
}

void playSound(int id,int channel) throw()
{
  if(Snd_effect(id,channel)==EXIT_FAILURE)
    cerr<<ERROR_PLAY_SOUND;
}

void setVolumeSound(int id,int volume) throw()
{
  if(Snd_setVolume(id,volume)==EXIT_FAILURE)
    cerr<<ERROR_VOLUME_SOUND;
}

void stopSoundChannel(int channel) throw()
{
  if(Snd_resetChannel(channel)==EXIT_FAILURE)
    cerr<<ERROR_STOP_SOUND_CHANNEL;
}
