/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include <iostream.h>
#include <stdio.h>
#include <string.h>

#include "mem_function.h"


void memPutSprite(const Pixel *data,
		  const Pixel *mask,
		  Pixel *dest,
		  int count)
{
  register const Pixel *_data=data;
  register const Pixel *_mask=mask;
  register Pixel *_dest=dest;
  
  register Pixel *_end=_dest+count;

  if(pixelGrey) {
    while(_dest<_end) {
      
      *_dest = palettePassGrey((*_dest & *_mask) | *_data) | pixelGetLuz(*_dest);

      _mask++;
      _dest++;
      _data++;
    }
  }
  else 
    while(_dest<_end) {

      *_dest = palettePass((*_dest & *_mask) | *_data) | pixelGetLuz(*_dest);

      _mask++;
      _dest++;
      _data++;
      
    }
}

void memPutSpriteUnderMask(const Pixel *data,
			   const Pixel *mask,
			   Pixel *dest,
			   const uchar *underMask,
			   int count)
{
  
  register const Pixel *_data=data;
  register const Pixel *_mask=mask;
  register Pixel *_dest=dest;
  register const uchar *_underMask=underMask;
  
  register Pixel *_end=_dest+count;
  /*
  if(pixelGrey) {
    while(_dest<_end) {

      if(*_underMask)
	*_dest = palettePassGrey((*_dest & *_mask) | *_data) | pixelGetLuz(*_dest);

      _mask++;
      _dest++;
      _data++;

      _underMask++;
    }
  }
  else */
    while(_dest<_end) {

      if(*_underMask)	
	*_dest = palettePass((*_dest & *_mask) | *_data) | pixelGetLuz(*_dest);

      _mask++;
      _dest++;
      _data++;
      
      _underMask++;
    }
}

void memPutSpriteColor(Pixel color,
		       const Pixel *data,
		       Pixel *dest,
		       int count)
{
  register const Pixel *_data=data;
  register Pixel *_dest=dest;
  
  register Pixel *_end=_dest+count-1;

  if(pixelGrey) {
    while(_dest<_end) {
      
      if(*_data) {
	*_dest = palettePassGrey(color);//palettePassGrey((*_dest & *_mask) | *_data) | pixelGetLuz(*_dest);
	*(_dest + 1) = toPixel(0,0,0,0);
      }

      _data++;
      _dest++;
    }
  }
  else {
    while(_dest<_end) {

      if(*_data) {
	*_dest = color;//palettePass(color);//palettePass((*_dest & *_mask) | *_data) | pixelGetLuz(*_dest);
	*(_dest + 1) = toPixel(0,0,0,0);
      }

      _data++;
      _dest++;
    }
  }
}

void memPutSpriteUnderMaskPalette(const Pixel *data,
				  const Pixel *mask,
				  Pixel *dest,
				  const uchar *underMask,
				  int count,
				  const Pixel *pal)
{
  register const Pixel *_data=data;
  register const Pixel *_mask=mask;
  register Pixel *_dest=dest;
  register const uchar *_underMask=underMask;
  
  register Pixel *_end=_dest+count;

  if(pixelGrey) {
    while(_dest<_end) {

      if(*_underMask)
	*_dest = palettePassGrey((*_dest & *_mask) | pal[*_data]) | pixelGetLuz(*_dest);

      _mask++;
      _dest++;
      _data++;

      _underMask++;
    }
  }
  else 
    while(_dest<_end) {

      if(*_underMask)
	*_dest = palettePass((*_dest & *_mask) | pal[*_data]) | pixelGetLuz(*_dest);

      _mask++;
      _dest++;
      _data++;
      
      _underMask++;
    }
}


void memCopy(const Pixel *src,
	     Pixel *dest,
	     int count)
{
  if(pixelGrey) {
    for(int k=0;k<count;k++)
      *(dest+k)=palettePassGrey(*(src+k)) | pixelGetLuz(*(src+k));
  }
  else {
   memmove(dest,src,count*sizeof(Pixel));
   /*
    register Pixel o;

    for(int k=0;k<count;k++) {
      o=*(src+k);
      //      *(dest+k)=palettePass(*(src+k)) | (*(src+k) & 0x8000);
//PIXEL      *(dest+k)=palettePass(o) | (o & 0x8000);
      *(dest+k)=palettePass(o) | (o & pixelGetLuz(o));//0x0100);
    }
   */
  }
}


void memClear(Pixel *dest,int count)
{
  memset(dest,0,count*sizeof(Pixel));
}

void memSet(Pixel *dest,Pixel p,int count)
{
  memset(dest,p,count*sizeof(Pixel));
}

