/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#ifndef __mem_function_h__
#define __mem_function_h__

#include "Pixel.h"


//author David FAUTHOUX

//pour ne pas gerer le shadow : mask=0x0+0x7fff=0x7fff

//poids fort de mask(luz)=1 (sauf cas non using luz,cf avant)
void memPutSprite(const Pixel *data,
		  const Pixel *mask,
		  Pixel *dest,
		  int count);

void memPutSpriteUnderMask(const Pixel *data,
			   const Pixel *mask,
			   Pixel *dest,
			   const uchar *underMask,
			   int count);

void memPutSpriteColor(Pixel color,
		       const Pixel *data,
		       Pixel *dest,
		       int count);

void memPutSpriteUnderMaskPalette(const Pixel *data,
				  const Pixel *mask,
				  Pixel *dest,
				  const uchar *underMask,
				  int count,
				  const Pixel *pal);

void memCopy(const Pixel *src,
	     Pixel *dest,
	     int count);

void memClear(Pixel *dest,int count);

void memSet(Pixel *dest,Pixel p,int count);


#endif
