/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */

//This code works but is very bad, sorry, quick coding !

/*
  ATTENTION ! This setup use svgalib !!!
  Search vga to modify.
*/

#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include "Ini.h"
#include "Keyer.h"
#include "Paintable.h"
#include "TextPainter.h"
#include "File.h"
#include "GraphicMode.h"
#include "WindowPipe.h"
#include "Sounder.h"
#include "util.h"
#include "GifIn.h"
#include "List.h"
#include "AddOnScriptAnalyser.h"
#include "Background.h"

#define DEFAULT_FREQUENCY 11025
#define DEFAULT_NB_CHANNEL 16
#define DEFAULT_SOUND_DEVICE "/dev/dsp"
#define DEFAULT_SOUND_TEST "Sound/Boum0.raw"

bool svgalibOk;

class KeyCatcher:public Keyable {
protected:
  ///
  GraphicMode *graphicModeRef;

  ///
  TextPainter textPainter;
  ///
  List< const String * > file;
  ///
  List< const String * > list;
  ///
  const String *current;

  ///
  List< const String * > fileAddons;
  ///
  List< const String * > listAddons;
  ///
  List< bool > addedAddons;
  ///
  List< bool > cocheAddons;
  ///
  const String *currentAddon;

  ///
  Pixel backgroundColor;
  ///
  Pixel fontColor;
  ///
  Pixel backgroundColorSelect;
  ///
  Pixel fontColorSelect;
  ///
  List< int > keyUp;
  ///
  List< int > keyDown;
  ///
  List< int > keyOk;
  ///
  List< int > keyCancel;

  ///
  int jPosition;

  ///
  int step;

  ///
  Ini *iniLanguage;

  ///
  const String *pathAddons;

  ///
  Sounder *sounder;

public:
  bool ok;
  bool cancel;
  Background *globalBackground;
protected:

  ///
  void setKeyList(Ini& ini,List< int >& l,const String& id,int defaultValue) throw() {
    l.place();
    while(l.walk()) l.suppr();

    List< const String * > *aux=ini.getListWithoutException("[Setup]",0,id);
    if(!aux || aux->empty()) {
      l.put(defaultValue);
    }
    else {
      try {
	aux->place();
	while(aux->walk()) l.put(aux->get()->toInt());
      } catch(Exception) {
	cout<<"Setting default value\n";
	l.put(defaultValue);
      }
    }
  }

  ///
  bool compareKey(int k,List< int >& l) throw() {
    l.place();
    while(l.walk()) if(l.get()==k) return true;
    return false;
  }

  ///
  void testGraphicMode() throw() {
    cout<<"Testing graphic mode...\n";cout.flush();
    if(svgalibOk) {
      cout<<"Graphic mode ok.\n";cout.flush();
      step=2;
      if(system("ln -fs Pixel.h.32k src/Pixel.h"))
	cerr<<"Error : Cannot link Pixel.h !\n";
    }
    else {
      step=4;
      cerr<<"Graphic mode error. Running in 256 colors.\n";cerr.flush();
      if(system("ln -fs Pixel.h.256 src/Pixel.h"))
	cerr<<"Error : Cannot link Pixel.h !\n";
    }
  }

  ///
  void testSound() throw() {
    try {
      int soundId=
	sounder->add(*(iniLanguage->getWithDefault("[Sound]",0,
						   "sound test",0,
						   DEFAULT_SOUND_TEST)));
      sounder->play(soundId);
    } catch(Exception) {
      step=5;
    }
  }

  ///
  void calcAddons() throw() {

    if(system((const char *)(*new String("ls -1 --color=no ")
			     +*pathAddons
			     +*new String(" > .setup.out")))) {
      cerr<<"Error : Cannot execute 'ls' command\n";cerr.flush();
      return;
    }
    system("mkdir tmp 2> .setup.tar.out");
    try {
      File ftrash(".setup.out");
      while(!ftrash.eof()) {
	String *s;

	ftrash.read(s);
	
	String t0("cd tmp ; tar -xvzf ../");
	String t1(" | head -1 > ../.setup.tar.out ; cd ..");

	if(system((const char *)(t0+*pathAddons+*s+t1))) {
	  cerr<<"Error : Cannot create the temporary file .setup.tar.out\n";
	}
	else {
	  try {
	    String *t;

	    File ftar(".setup.tar.out");
	    
	    ftar.read(t);
	    
	    AddOnScriptAnalyser addonScript(*new String("tmp/")+*t,false);
	    addedAddons.put(addonScript.checkIfAlready("src/.addon"));
	    
	    cocheAddons.put(false);

	    fileAddons.put(s);
	    listAddons.put(t);

	    cout<<"Found addon file : "<<(const char *)*fileAddons.get()<<"\n";
	    cout<<"-> addon script : "<<(const char *)*listAddons.get()<<"\n";
	    if(addedAddons.get()) cout<<"-> already added\n";
	    else cout<<"-> not added\n";
	    cout.flush();
	  } catch(Exception) {
	    cerr<<"Error : with the temporary file .setup.tar.out\n";
	  }
	}
      }

      listAddons.place();
      fileAddons.place();
      addedAddons.place();
      cocheAddons.place();
      if(!listAddons.empty()) {
	listAddons.walk();
	currentAddon=listAddons.get();
	fileAddons.walk();
	addedAddons.walk();
	cocheAddons.walk();
      }

    } catch(Exception) {
      cerr<<"Error : Cannot create/open the temporary file .setup.out\n";
    }

    system("rm -fR tmp/");
    system("rm -f .setup*");

  }

  ///
  void addAddon() throw() {

    cout<<"Adding addon :";
    cout<<(const char *)(*pathAddons+*fileAddons.get())<<"\n";
    cout<<"-> "<<(const char *)(*listAddons.get())<<"\n";cout.flush();

    if(system((const char *)(*new String("tar xfz ")+*pathAddons+*fileAddons.get()))) {
      cerr<<"Error : Cannot untar the addon : "<<(const char *)(*pathAddons+*fileAddons.get())<<"\n";cerr.flush();
    } else 
      if(system((const char *)(*new String("(cd src ; ./addon --add ../")+*listAddons.get()+*new String(")")))) {
	cerr<<"I remove the addon.\n";cerr.flush();
	system((const char *)(*new String("(cd src ; ./addon --remove ../")+*listAddons.get()+*new String(")")));
      }
  }
  
  ///
  void removeAddon() throw() {

    cout<<"Removing addon :";
    cout<<(const char *)(*pathAddons+*fileAddons.get())<<"\n";
    cout<<"-> "<<(const char *)(*listAddons.get())<<"\n";cout.flush();

    system((const char *)(*new String("(cd src ; ./addon --remove ../")+*listAddons.get()+*new String(")")));
  }
  
  ///
  void updateAddons() throw() {
    cocheAddons.place();
    fileAddons.place();
    listAddons.place();
    addedAddons.place();
    bool co=false;
    while(cocheAddons.walk()) {
      fileAddons.walk();
      listAddons.walk();
      addedAddons.walk();
      if(cocheAddons.get()) {
	co=true;
	if(addedAddons.get()) removeAddon();
	else addAddon();
      }
    }
    if(co) {
      cout<<"The program needs to be recompiled. Running 'make'...\n";cout.flush();
      if(system("(cd src;make depend > /dev/null 2> /dev/null;make)")) {
	cerr<<"I CANNOT COMPILE !!! Please remove the buggy addon by running setup.\n";cerr.flush();
      }
    }
  }


public:
  ///
  KeyCatcher(GraphicMode& graphicMode,Ini& ini,List< const String * > & fileList) throw(Exception)
    :graphicModeRef(&graphicMode),
     textPainter(ini),
     file(fileList),
     backgroundColor(ini.getWithDefaultColor("[Setup]",0,"background color",0,toPixel(0,0,0,0))),
     fontColor(ini.getWithDefaultColor("[Setup]",0,"font color",0,toPixel(33,20,33,0))),
     backgroundColorSelect(ini.getWithDefaultColor("[Setup]",0,"background color select",0,toPixel(224,0,0,0))),
     fontColorSelect(ini.getWithDefaultColor("[Setup]",0,"font color select",0,toPixel(40,0,0,0))),
     jPosition(ini.getWithDefault("[Setup]",0,"j position for text",0,40)),
     step(0),
     iniLanguage(0),
     pathAddons(0),
     sounder(0),
     ok(false),
     cancel(false),
     globalBackground(new Background(0,*graphicModeRef,0,0))
    {
    if(fileList.empty()) throw Exception("Exception : KeyCatcher cannot manage an empty list");

    file.place();
    while(file.walk()) {
      Ini auxIni(*file.get());
      const String *l=auxIni.getWithDefault("[Setup]",0,"language",0,*new String("unknown language"));

      if(l->size()==0) list.put(new String("unknown language"));
      else list.put(new String(*l));

      cout<<"Found language : "<<(const char *)*list.get()<<"\n";
    }
  
    list.place();
    list.walk();
    current=list.get();
    file.place();
    file.walk();

    setKeyList(ini,keyUp,"key up",103);
    setKeyList(ini,keyDown,"key down",108);
    setKeyList(ini,keyCancel,"key esc",1);
    setKeyList(ini,keyOk,"key enter",28);
  }

  ///
  virtual ~KeyCatcher() throw() {
    
    updateAddons();

    if(iniLanguage) {
/*      try {
	cout<<"Saving "<<(const char *)*file.get()<<"\n";
	iniLanguage->save();
      } catch(Exception) {
	cerr<<"Error : Cannot save "<<(const char *)*file.get()<<"\n";
      }*/
      delete iniLanguage;
    }

    delete globalBackground;
    if(sounder) delete sounder;
  }
  ///
  virtual void keyAction(const Key& key) throw() {
    if(key.isUp()) return;
    
    switch(step) {
    case 0:

      if(compareKey(key.getCode(),keyDown)) {
	list.place();
	file.place();
	while(list.walk()) {
	  file.walk();
	  if(list.get()==current) {
	    if(list.walk()) current=list.get();
	    file.walk();
	    break;
	  }
	}
      }
      if(compareKey(key.getCode(),keyUp)) {
	list.place();
	file.place();
	const String *s=0;
	while(list.walk()) {
	  file.walk();
	  if(list.get()==current) {
	    if(s!=0) current=s;
	    break;
	  }
	  s=list.get();
	}
      }
      if(compareKey(key.getCode(),keyOk)) {
	list.place();
	file.place();
	while(list.walk()) {
	  file.walk();
	  if(list.get()==current) break;
	}

	step=1;
	cout<<"Linking bomb.ini to "<<(const char *)*file.get()<<"\n";cout.flush();
	if(system((const char *)(*new String("ln -fs ")+*file.get()+*new String(" bomb.ini")))) {
	  cerr<<"Error : Cannot link !\n";
	}
	iniLanguage=new Ini(*file.get());

	sounder=new Sounder(iniLanguage->getWithDefault("[Sound]",0,
							"frequency",0,
							DEFAULT_FREQUENCY),
			    iniLanguage->getWithDefault("[Sound]",0,
							"number of channel",0,
							DEFAULT_NB_CHANNEL),
			    *(iniLanguage->getWithDefault("[Sound]",0,
							  "sound device",0,
							  DEFAULT_SOUND_DEVICE)));

	setKeyList(*iniLanguage,keyUp,"key up",103);
	setKeyList(*iniLanguage,keyDown,"key down",108);
	setKeyList(*iniLanguage,keyCancel,"key esc",1);
	setKeyList(*iniLanguage,keyOk,"key enter",28);

	try {
	  delete globalBackground;
	  globalBackground=new Background(iniLanguage->get("[Setup]",0,"background",0),*graphicModeRef,10,10);
	} catch(Exception) {
	  cerr<<"Warning : I cannot found a valid background gif.\n";cerr.flush();
	  globalBackground=new Background(0,*graphicModeRef,0,0);
	}

	
	pathAddons=new String(*iniLanguage->getWithDefault("[Setup]",0,"path addons",0,"addons/"));

	if(pathAddons->size()<=0) {
	  pathAddons=new String("addons/");
	  iniLanguage->set("[Setup]",0,"path addons",0,*pathAddons);
	}
	if((*pathAddons)[pathAddons->size()-1]!='/') {
	  pathAddons=new String(*pathAddons+*new String("/"));
	  iniLanguage->set("[Setup]",0,"path addons",0,*pathAddons);
	}

	cout<<"Path to search addons : "<<(const char *)*pathAddons<<"\n (found in '[Setup]' of the initialisation file)\n";cout.flush();
	
	//SOUNDER
	cout<<"Testing sound...\n";cout.flush();
	testSound();

      }
      if(compareKey(key.getCode(),keyCancel)) {
	//	cancel=true;
      }
      break;

    case 1:
      //test sound

      if(compareKey(key.getCode(),keyOk)) {
	cout<<"Sound ok.\n";cout.flush();
	//GRAPHIC MODE
	testGraphicMode();
      }
      if(compareKey(key.getCode(),keyCancel)) {
	cerr<<"Sound error.\n";cerr.flush();
	step=3;
      }
      break;

    case 2:
      calcAddons();
      if(listAddons.empty()) ok=true;
      else step=6;
      break;
    case 4:
      if(compareKey(key.getCode(),keyOk) ||compareKey(key.getCode(),keyCancel)) {
	calcAddons();
	if(listAddons.empty()) ok=true;
	else step=6;
      }
      break;

    case 3:
    case 5:
      if(compareKey(key.getCode(),keyOk) || compareKey(key.getCode(),keyCancel)) {
	testGraphicMode();
      }
      break;

    case 6:

      if(compareKey(key.getCode(),keyDown)) {
	listAddons.place();
	fileAddons.place();
	cocheAddons.place();
	addedAddons.place(); 
	while(listAddons.walk()) {
	  fileAddons.walk();
	  cocheAddons.walk();
	  addedAddons.walk(); 
	  if(listAddons.get()==currentAddon) {
	    if(listAddons.walk()) currentAddon=listAddons.get();
	    fileAddons.walk();
	    break;
	  }
	}
      }
      if(compareKey(key.getCode(),keyUp)) {
	listAddons.place();
	fileAddons.place();
	cocheAddons.place();
	addedAddons.place(); 
	const String *s=0;
	while(listAddons.walk()) {
	  fileAddons.walk();
	  cocheAddons.walk();
	  addedAddons.walk(); 
	  if(listAddons.get()==currentAddon) {
	    if(s!=0) currentAddon=s;
	    break;
	  }
	  s=listAddons.get();
	}
      }
      if(compareKey(key.getCode(),keyOk)) {
	listAddons.place();
	cocheAddons.place();
	while(listAddons.walk()) {
	  cocheAddons.walk();
	  if(listAddons.get()==currentAddon) {
	    bool b=cocheAddons.get();
	    cocheAddons.suppr();
	    cocheAddons.put(!b);
	    return;
	  }
	}
      }
      if(compareKey(key.getCode(),keyCancel)) {
	//	cancel=true;
	ok=true;
      }
      break;
    
    }
  
  }
  
  ///
  int cutAndPaintText(int pos,WindowPipe& windowPipe,const String& t,Pixel fontColor,Pixel backgroundColor,int j=0) throw() {
    List< char > auxList0;
    List< char > auxList1;
    int kk=pos;
    while(kk>=0) {
      auxList0.placeCurrentOnQueue();
      auxList0.put(t[kk]);
      kk--;
    }
    kk=pos+1;
    while(kk<t.size()) {
      auxList1.put(t[kk]);
      kk++;
    }
    String *s0=new String(auxList0);
    String *s1=new String(auxList1);
    paintText(windowPipe,*s0,fontColor,backgroundColor,j);
    return paintText(windowPipe,*s1,fontColor,backgroundColor,j+textPainter.nbLine());
    delete s0;
    delete s1;
  }

  ///
  int paintText(WindowPipe& windowPipe,const String& t,Pixel fontColor,Pixel backgroundColor,int j=0) throw() {
    int wj,wi,wsj,wsi;
    windowPipe.getFrom(wj,wi,wsj,wsi);

    int tsi=t.size()*textPainter.nbColumn();
    if(tsi>wsi) {
      int pos=wsi/textPainter.nbColumn();
      int k=pos-1;
      while(k>=0) {
	if(isBlank(t[k]) || isSeparator(t[k])) {
	  return cutAndPaintText(k,windowPipe,t,fontColor,backgroundColor,j);
	}
	k--;
      }
      return cutAndPaintText(pos,windowPipe,t,fontColor,backgroundColor,j);
    }
    else {
      int i=wsi/2-tsi/2;
      textPainter.paint(windowPipe,
			j+jPosition,i,
			t,
			fontColor,backgroundColor);
      return j+textPainter.nbLine();
    }
  }

  ///
  void virtual paint() throw() {
    globalBackground->paint();

    WindowPipe *windowPipe=globalBackground->getWindowPipe();

    switch(step) {
    case 0: {

      int j=0;
      
      list.place();
      while(list.walk()) {
	Pixel bColor=backgroundColor;
	Pixel fColor=fontColor;
	if(current==list.get()) {
	  bColor=backgroundColorSelect;
	  fColor=fontColorSelect;
	}
	paintText(*windowPipe,*list.get(),fColor,bColor,j);
	j+=textPainter.nbLine();
      }
      break;
    }
    case 1: {
      paintText(*windowPipe,*iniLanguage->getWithDefault("[Setup]",0,"sound test",0,"Did you hear the sound ?"),fontColor,backgroundColor);
      break;
    }
    case 2:
      break;
    case 3: {
      paintText(*windowPipe,*iniLanguage->getWithDefault("[Setup]",0,"sound error",0,"Try to run 'sndconfig' or try to change 'sound device' in 'bomb.ini'"),fontColor,backgroundColor);
      break;
    }
    case 4: {
      paintText(*windowPipe,*iniLanguage->getWithDefault("[Setup]",0,"graphic mode error",0,"Graphic mode test failed : cannot run the game in thousand colors, running in 256 colors."),fontColor,backgroundColor);
      break;
    }
    case 5: {
      paintText(*windowPipe,*iniLanguage->getWithDefault("[Setup]",0,"sound file not found",0,"I need a raw sound file to test ! Check 'sound test' in 'bomb.ini'"),fontColor,backgroundColor);
      break;
    }
    case 6: {

      int pj=paintText(*windowPipe,*iniLanguage->getWithDefault("[Setup]",0,"addons test",0,"Choose your addons"),fontColor,backgroundColor);
      pj+=textPainter.nbLine();

      int j=0;
      
      listAddons.place();
      addedAddons.place();
      cocheAddons.place();
      while(listAddons.walk()) {
	addedAddons.walk();
	cocheAddons.walk();
	Pixel bColor=backgroundColor;
	Pixel fColor=fontColor;
	if(currentAddon==listAddons.get()) {
	  bColor=backgroundColorSelect;
	  fColor=fontColorSelect;
	}
	
	List< char > auxChar;
	int kk=listAddons.get()->size()-1;
	while((*listAddons.get())[kk]!='/') {
	  auxChar.placeCurrentOnQueue();
	  auxChar.put((*listAddons.get())[kk]);
	  kk--;
	}

	auxChar.placeCurrentOnQueue();
	auxChar.put(' ');
	auxChar.placeCurrentOnQueue();
	if(addedAddons.get()) auxChar.put('*');
	else auxChar.put(' ');

	auxChar.placeCurrentOnQueue();
	if(cocheAddons.get()) {
	  if(addedAddons.get()) auxChar.put('-');
	  else auxChar.put('+');
	}
	else auxChar.put(' ');

	String *auxS=new String(auxChar);
	paintText(*windowPipe,*auxS,fColor,bColor,pj+j);
	delete auxS;
	j+=textPainter.nbLine();
      }
      break;
    }
    }
    windowPipe->refreshAll();
  }
};



int main(int argc,char** argv)
{
  svgalibOk=false;

  if(argc>1 && *new String(argv[1])==*new String("256")) {
  } else {
    if(vga_setmode(G320x200x32K)==0
       && gl_setcontextvga(G320x200x32K)==0) svgalibOk=true;
  }

  vga_setmode(TEXT);


  if(!File::exists("ini/bomb.english.ini") && !File::exists("bomb.ini")) {
    cerr<<"Error : I cannot find the initialisation file : bomb.ini or ini/bomb.english.ini\n";
  }
  system("ln -fs ini/bomb.english.ini bomb.ini");

  List<const String *> fileList;

  system("ls -1 --color=no ini/*.ini > .setup.out");
  try {
    File ftrash(".setup.out");
    while(!ftrash.eof()) {
      String *s;
      ftrash.read(s);
      fileList.put(s);
      cout<<"Found initialisation file : "<<(const char *)*fileList.get()<<"\n";
    }
  } catch(Exception) {
    cerr<<"Error : Cannot create/open the temporary file .setup.out\n";
    return 1;
  }
  
  if(fileList.empty()) {
    cerr<<"Error : I can't find initialisation files in ini/\n";
    return 1;
  }

  Ini *ini;
  try {
    ini=new Ini("bomb.ini");
  } catch(Exception) {
    cerr<<"Error : I cannot find the initialisation file : bomb.ini\n";
    return 1;
  }

  Keyer *keyer;
  try {
    keyer=new Keyer();
  } catch(Exception) {
    cerr<<"Error : Cannot initialised the keyboard\n";
    return 1;
  }

  GraphicMode *graphicMode=new GraphicMode(80);

  KeyCatcher keyCatcher(*graphicMode,*ini,fileList);

  keyer->add(keyCatcher);
  
  ////////////////////////////////////////
  ////////////////////////////////////////

  try {
    graphicMode->on();
    graphicMode->clear();
  } catch(Exception) {
    cerr<<"Error : Cannot initialise graphic mode\n";cerr.flush();
    delete graphicMode;
    return 1;
  }
  while(!keyCatcher.ok && !keyCatcher.cancel) {
    keyCatcher.paint();
    graphicMode->refresh();
    keyer->walk();
  }

  ////////////////////////////////////////
  ////////////////////////////////////////

  delete graphicMode;
  delete keyer;

  delete ini;
  
  return 0;
}
