/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include <stdlib.h>
#include <iostream.h>

#include "GraphicMode.h"
#include "Redirector.h"
#include "GifIn.h"
//#include "Palette.h"
#include "Keyer.h"

class Galber:public Keyable {
public:
  bool stop,blow;
  Galber():stop(false),blow(false) {}
  void keyAction(const Key& key) {
    if(key.isDown()) {
      if(key.getCode()==Key::ESCAPE) stop=true;
      if(key.getCode()==Key::SPACE) { cout<<"\7";cout.flush(); blow=true;}
    }
  }
};

#include "Blower.h"

// ****************** Main ******************

int main(int argc,char **argv)
{
  Keyer keyer;
  Galber galber;
  keyer.add(galber);

  GifIn pix("../Page/justForFun.gif");
 
  GraphicMode graphicMode(10);
  //  Palette palette;

  Blower blower(0);

  graphicMode.redirect(blower);

  graphicMode.on();
  /*
  for(int i=0;i<pix.getPalette()->size();i++) {
    int r,g,b;
    pix.getPalette()->get(i,r,g,b);
    palette.set(i,r>>2,g>>2,b>>2);
  }
  */
  //  palette.set(32,0,0,0);
  //  palette.set(33,63,63,63);

  //  graphicMode=*(pix.getBitmap()->getBitmap());

  graphicMode.clear();

  //  palette.walk();

  pix.place();
  pix.walk();

  Window wg(graphicMode);
  Window ws(*(pix.get()->getData()));
  UnderMaskMatrix u(200,320);
  WindowPipe wp(wg,ws,u);

  while(!galber.stop) {
    if(galber.blow) {
      blower.blowUp();
      galber.blow=false;
    }

    //    graphicMode.clear();
    wp.refreshAll();
    
    //    graphicMode=*(pix.get());

//     Point2D a(10,-40,0,0);
//     Point2D b(80,i,320,0);
//     Point2D c(30,80,320,200);

//     Triangle t(a,b,c);

//     t.fill(graphicMode,*(pix.getBitmap()->getBitmap()));

    blower.walk();
    graphicMode.refresh();
    keyer.walk();
  }


  galber.stop=false;

  return 0;
}

