/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "util.h"
#include "String.h"

bool listToPixel(List< int >& l,Pixel& p) throw()
{
  int rgb[3];
  int cpt=0;
  l.place();
  while(l.walk()) {
    rgb[cpt]=l.get();
    if(cpt==2) {
      p=toPixel(rgb[0],rgb[1],rgb[2],0);
      return true;
    }
    cpt++;
  }
  return false;
}


bool extractInt(const String& s,char separator,List<int>& l,KeyboardLanguage::Language keyboardLanguage) throw()
{
  //si on trouve un !=0..9 dans s, faire un charToInt des s[k]

  bool sentence=false;

  for(int k=0;k<s.size();k++)
    if(s[k]!=separator && (s[k]<'0' || s[k]>'9')) {
      sentence=true;
      break;
    }

  if(sentence) {

    KeyboardLanguage keybLanguage(keyboardLanguage);

    l.place();
    for(int k=0;k<s.size();k++) l.put(keybLanguage.getCode(s[k]));
      
  }
  else {

    int i=0;
    
    l.place();
    while(i<s.size()) {
      List<char> nb;
      while(i<s.size() && s[i]!=separator) {
	nb.put(s[i]);
	i++;
      }
      String *auxS=new String(nb);
      int aux;
      try {
	aux=auxS->toInt();
      } catch(Exception) {
      aux=0;
      }
      delete auxS;
      l.put(aux);
      i++;
    }
  }

  l.place();
  if(l.walk()) return true;
  return false;
}

String *downCase(const String& s) throw()
{
  String *ret=new String(s);
  for(int k=0;k<ret->size();k++)
    if((*ret)[k]>='A' && (*ret)[k]<='Z') {
      int c=(*ret)[k];
      c+='a'-'A';
      (*ret)[k]=c;
    }
  return ret;
}

String *simplifyBlank(const String& s) throw()
{
  List<char> list;
  bool blankGap=false;
  bool separatorFound=true;
  for(int i=0;i<s.size();i++) {
    if(isSeparator(s[i])) {
      list.put(s[i]);
      separatorFound=true;
    }
    else if(!isBlank(s[i])) {
      if(blankGap) {
	if(!separatorFound) {
	  list.put(BLANK_SPACE);
	}
	blankGap=false;
      }
      list.put(s[i]);
      separatorFound=false;
    }
    else if(!blankGap) {
      blankGap=true;
    }
  }
  return new String(list);

  /*old
  List<char> list;
  bool blankGap=false;
  for(int i=0;i<s.size();i++) {
    if(!isBlank(s[i])) {
      if(blankGap) {
	if(!list.empty()) list.put(BLANK_SPACE);
	blankGap=false;
      }
      list.put(s[i]);
    }
    else if(!blankGap) {
      blankGap=true;
    }
  }
  return new String(list);
  */
}

/*
  String *supprComment(const String& s) throw()
  {
  List<char> list;
  for(int i=0;i<s.size();i++)
  if(s[i]=='/') {
  if(i+1<s.size()) {
  i++;
  if(s[i]=='/') break;
  else if(s[i]=='*') {
  i++;
  while(i<s.size()) {
  if(s[i]=='*' && i+1<s.size() && s[i+1]==
  i++;
  }
  }
  }
  }
  else {
  if(s[i]=='/')
  }
  if(s[i]!=BLANK_SPACE && s[i]!=BLANK_TAB && s[i]!=BLANK_RETURN) list.put(s[i]);
  return new String(list);
  }
*/
/*%%
  char SEPARATOR[]=" \t\n";
  char SPECIAL_CHAR[]=":{}";
  
  List<String *> *createWordList(const String& s) throw()
  {
  List<String*> *wordList=new List<String*>;
  List<char> list;
  for(int i=0;i<s.size();i++) {
  bool sep=false;
  int k=0;
  while(SEPARATOR[k]) {
  if(s[i]==SEPARATOR[k]) {
  sep=true;
  break;
  }
  k++;
  }
  
  bool special=false;
  k=0;
  while(SPECIAL_CHAR[k]) {
  if(s[i]==SPECIAL_CHAR[k]) {
  special=true;
  break;
  }
  k++;
  }
  
  if(special) {
  if(!list.empty()) {
  wordList->put(new String(list));
  list.place();
  while(list.walk()) list.suppr();
  }
  char specialString[2]={s[i],0};
  wordList->put(new String(specialString));
  }
  else if(!sep) list.put(s[i]);
  else if(!list.empty()) {
  wordList->put(new String(list));
  list.place();
  while(list.walk()) list.suppr();
  }
  }
  return wordList;
  }
*/


bool isBlank(char c) throw()
{
  return (c==BLANK_SPACE || c==BLANK_TAB || c==BLANK_RETURN);
}

bool isSeparator(char c) throw()
{
  return (c==SEPARATOR_STAR ||
	  c==SEPARATOR_SLASH ||
	  c==SEPARATOR_AND ||
	  c==SEPARATOR_OPEN_BRACE || c==SEPARATOR_CLOSE_BRACE ||
	  c==SEPARATOR_OPEN_BRACKET || c==SEPARATOR_CLOSE_BRACKET ||
	  c==SEPARATOR_INFERIOR || c==SEPARATOR_SUPERIOR ||
	  c==SEPARATOR_SEMI_COLON || c==SEPARATOR_COLON ||
	  c==SEPARATOR_COMA ||
	  c==SEPARATOR_EQUAL);
}

bool isCapital(char c) throw()
{
  return (c>='A' && c<='Z');
}
